if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

sape.toolbar.seobudget =
{
    uid: null,
    pid: '51f21418fdabf7beab3d47c751ab1cdb',
};

sape.toolbar.seobudget.onLoad = function()
{
     var info = sape.toolbar.seobudget.getLogin();
     document.getElementById("seobudget-login-field").value = info.login;
     document.getElementById("seobudget-password-field").value = info.password;
};

sape.toolbar.seobudget.onAccept = function()
{
     var u = document.getElementById("seobudget-login-field");
     var p = document.getElementById("seobudget-password-field");
     sape.toolbar.seobudget.setLogin(u.value, p.value);
     return true;
};

sape.toolbar.seobudget.getLogin = function()
{
    var info = {login: null, password: null};
    var host = "chrome://wmsape/seobudget";

    if ("@mozilla.org/login-manager;1" in Components.classes)
    {
        try
        {
            var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var logins = myLoginManager.findLogins({}, host, null, 'SEOBudget Registration');
            if (logins.length)
            {
                info.login = logins[0].username;
                info.password = logins[0].password;
            }
            if (logins.length > 1)
            {
                try
                {
                    var oldLoginInfo = new nsLoginInfo(host, null, 'SEOBudget Registration', logins[1].username, logins[1].password, "", "");
                    myLoginManager.removeLogin(oldLoginInfo);
                }
                catch(ex) {}
            }
        }
        catch(ex) {}
     }
     return info;
};

sape.toolbar.seobudget.setLogin = function(login, password)
{
    var host = "chrome://wmsape/seobudget";
    var info = sape.toolbar.seobudget.getLogin();

    if ("@mozilla.org/login-manager;1" in Components.classes)
    {
        try
        {
            var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
            try
            {
                var oldLoginInfo = new nsLoginInfo(host, null, 'SEOBudget Registration', info.login, info.password, "", "");
                myLoginManager.removeLogin(oldLoginInfo);
            }
            catch(ex) {}

            var newLoginInfo = new nsLoginInfo(host, null, 'SEOBudget Registration', login, password, "", "");
            myLoginManager.addLogin(newLoginInfo);
        }
        catch(ex) {}
    }
};

sape.toolbar.seobudget.init = function()
{
    function md5(str)
    {
        return sape.toolbar.md5(str);
    }
    function guid(login, password)
	{
        if (login && password)
        if (login.length && password.length) return md5(md5(login) + md5(password + md5(login)));
        return null;
    }
    var info = sape.toolbar.seobudget.getLogin();
    sape.toolbar.seobudget.uid = guid(info.login, info.password);
};

// -----------------------------------------------
// Проверка проиндексированности страницы (YAP)
// -----------------------------------------------

sape.toolbar.seobudget.yap = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.yap;

    var host   = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
    var hlink  = 'http://' + host + '/';
    var data   = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=pindex&param1[]=' + st.safeEncode(link);
    var age    = st.cache.age(link, 'history');

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                requestTimer.cancel();

                var result = req.responseText;
                if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                    me.inProgress = 0;
                    crow.removeAttribute('yap');
                    return;
                }
                if (result.match(/BAD UID OR HAVE NO MONEY/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'),  st.str('seobudget.inc.login'), 2);
                    me.inProgress = 0;
                    crow.removeAttribute('yap');
                    return;
                }
                if (parseInt(result, 10) == 0)
                {
                    if (!age && me.lay.history) st.cache.push(link, 'history', 404);
                    if (age) place.setAttribute("title", st.str('yap.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                    place.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(checkbox.checked) && ((age <= me.history.age) && me.history.use))
                    {
                        place.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                    }
                    if (!(checkbox.checked) && ((age > me.history.age) || !me.history.use))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
                    if (ya.icache) st.cache.push(link, 'yap.' + ya.yandexcheck, 404);
                }
                if (parseInt(result, 10) == 1)
                {
                    st.cache.del(link, 'history');
                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    if (ya.icache)
                    {
                        st.cache.push(link,   'yap.' + ya.yandexcheck,  200);
                    }
                }
                if (parseInt(result, 10) == -1)
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
                }
                if (me.inProgress) ya.next(ya.yap);
                return;
            }
            else
            {
                requestTimer.cancel();
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                {
                    checkbox.checked = true;
                    me.counter++;
                }
                if (me.inProgress) ya.next(ya.yap);
                return;
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка проиндексированности ссылок (YAL)
// -----------------------------------------------
sape.toolbar.seobudget.yal = function(link, text, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.yal;

    var host   = link.split("/")[2].replace(/^www\./i, '');
    var hlink  = 'http://' + host + '/';
    var clink  = link + '++' + text;
    var age    = st.cache.age(clink, 'history');

    var data   = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=lindex&param1[]=' + st.safeEncode(link) + '&param2[]=' + st.safeEncode(text);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                requestTimer.cancel();

                var result = req.responseText;
                if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                    me.inProgress = 0;
                    crow.removeAttribute('yal');
                    return;
                }
                if (result.match(/BAD UID OR HAVE NO MONEY/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.login'), 2);
                    me.inProgress = 0;
                    crow.removeAttribute('yal');
                    return;
                }
                if (parseInt(result, 10) == 0)
                {
                    if (!age && me.lay.history) st.cache.push(clink, 'history', 404);
                    if (age) place.setAttribute("title", st.str('yal.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                    place.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(checkbox.checked) && ((age <= me.history.age) && me.history.use))
                    {
                        place.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                    }
                    if (!(checkbox.checked) && ((age > me.history.age) || !me.history.use))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
                    if (ya.icache) st.cache.push(clink, 'yal.' + ya.yandexcheck, 404);
                }
                if (parseInt(result, 10) == 1)
                {
                    st.cache.del(link, 'history');
                    st.cache.del(clink, 'history');
                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    if (ya.icache)
                    {
                        st.cache.push(clink, 'yal.' + ya.yandexcheck,  200);
                        st.cache.push(link,  'yap.' + ya.yandexcheck,  200);
                    }
                }
                if (parseInt(result, 10) == -1)
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    if (ya.errcheck && !(checkbox.checked)  && !(me.history.use))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
                }
                if (me.inProgress) ya.next(ya.yal);
                return;
            }
            else
            {
                requestTimer.cancel();
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                {
                    checkbox.checked = true;
                    me.counter++;
                }
                if (me.inProgress) ya.next(ya.yal);
                return;
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка проиндексированности ссылки url c анкором text размещенной на странице link в Google (GL)
// -----------------------------------------------
sape.toolbar.seobudget.gl = function(link, text, url, place, row)
{
    var st  = sape.toolbar, me = st.google.gl;
    var col = row.getElementsByTagName('td');
    var q   = me.query(link, me.gettext(col[me.tc]));

    if (row.hasAttribute('gl')) return;
        row.setAttribute('gl', '1');

    var cl    = me.query(link, url);
    var cache = (st.google.icache)? st.cache.pop(q, 'gc') : null;
    if (cache != null)
    {
        if (cache == 404)
        {
            place.setAttribute("style", "color:white !important; background-color:red !important;");
            var box = col[me.lay.check].getElementsByTagName('input');
            if (box && !box[0].checked)
            {
                box[0].checked = true;
                me.counter++;
            }
        }
        if (cache.match(/^http/))
        {
            place.setAttribute("style", "color:white !important; background-color:green !important;");
        }
        return st.google.next(me, 100);
    }

    var data   = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=lindexgoogle&param1[]=' + st.safeEncode(link) + '&param2[]=' + st.safeEncode(text) + '&param3[]=' + st.safeEncode(url);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                requestTimer.cancel();

                var result = req.responseText;
                if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                    me.inProgress = 0;
                    row.removeAttribute('gl');
                    return;
                }
                if (result.match(/BAD UID OR HAVE NO MONEY/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.login'), 2);
                    me.inProgress = 0;
                    row.removeAttribute('gl');
                    return;
                }
                if (parseInt(result, 10) > 0)
                {
                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    if (st.google.icache) st.cache.push(q,  'gc', st.google.requestURL + st.urlEncode(q));
                }
                if (parseInt(result, 10) == 0)
                {
                    place.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (st.google.icache) st.cache.push(q, 'gc', 404);

                    var box = col[me.lay.check].getElementsByTagName('input');
                    if (box && !box[0].checked)
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                if ((parseInt(result, 10) < 0)  || (result.match(/Error/i)))
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                }
                return st.google.next(me, 500);
            }
            else
            {
                requestTimer.cancel();
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                return st.google.next(me, 500);
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка кэша Google
// -----------------------------------------------
sape.toolbar.seobudget.cache = function(link, place, row)
{
    var st = sape.toolbar, me = st.google.gc;
    var col = row.getElementsByTagName('td');

    if (row.hasAttribute('gc.2')) return;
        row.setAttribute('gc.2', '1');

    var cl   = me.query(link, 2);
    var data = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=pgooglecachedate&param1[]=' + st.safeEncode(link);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                requestTimer.cancel();

                var result = req.responseText;
                if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                    me.inProgress = 0;
                    row.removeAttribute('gc.2');
                    return;
                }
                if (result.match(/BAD UID OR HAVE NO MONEY/i))
                {
                    if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.login'), 2);
                    me.inProgress = 0;
                    row.removeAttribute('gc.2');
                    return;
                }
                if ((parseInt(result, 10) == 0) || (result.match(/No cache/i)))
                {
                    place.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (st.google.icache) st.cache.push(cl, 'gc', 404);

                    var box = col[me.lay.check].getElementsByTagName('input');
                    if (box && !box[0].checked)
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                if (parseInt(result, 10) > 0)
                {
                    var fz = function(n) {return "" + ((n > 9)? n : "0" + n)};

                    var pageDate = new Date(parseInt(result, 10) * 1000);
                    var strDate  = fz(pageDate.getDate()) + '.' + fz(pageDate.getMonth() + 1) + '.' + pageDate.getFullYear();

                    place.setAttribute("style", "color:white !important; background-color:green !important;");
                    me.placeDate(col[me.lay.ico], strDate);
                    if (st.google.icache)
                    {
                        st.cache.push(cl,  'gc', st.google.requestURL + st.urlEncode(cl));
                        st.cache.push(cl,  'gcd', strDate);
                    }
                }
                if ((parseInt(result, 10) < 0)  || (result.match(/Error/i)))
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                }
                return st.google.next(me, 500);
            }
            else
            {
                requestTimer.cancel();
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                return st.google.next(me, 500);
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка на вылет из индекса (HOST)
// -----------------------------------------------

sape.toolbar.seobudget.host = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.host;

    var host  = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
    var hlink = 'http://' + host + '/';
    var data  = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=sindex&engine=yandex&param1[]=' + st.safeEncode(hlink);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                   requestTimer.cancel();

                   var result = req.responseText;
                   if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
                   {
                        if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                        me.inProgress = 0;
                        crow.removeAttribute('host');
                        return;
                   }
                   if (result.match(/BAD UID OR HAVE NO MONEY/i))
                   {
                        if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.login'), 2);
                        me.inProgress = 0;
                        crow.removeAttribute('host');
                        return;
                   }
                   var cnt = parseInt(result, 10);
                   if (cnt == 0)
                   {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");
                        if (!(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                        if (ya.icache) st.cache.push(hlink, 'host.' + ya.yandexcheck, 0);
                   }
                   if (cnt > 0)
                   {
                       place.setAttribute("style", "color:white !important; background-color:green !important;");
                       if (ya.icache) st.cache.push(hlink, 'host.' + ya.yandexcheck, cnt);
                   }
                   if (me.showcounters && (cnt !== -1))
                   {
                       var col = crow.getElementsByTagName('td');
                       me.placeCounter(col[me.lc], cnt);
                   }
                   if (cnt == -1)
                   {
                       place.setAttribute("style", "color:white !important; background-color:silver !important;");
                       if (ya.errcheck && !(checkbox.checked))
                       {
                           checkbox.checked = true;
                           me.counter++;
                       }
                   }
                   if (me.inProgress) ya.next(ya.host);
                   return;
            }
            else
            {
                   requestTimer.cancel();
                   place.setAttribute("style", "color:white !important; background-color:silver !important;");
                   if (ya.errcheck && !(checkbox.checked))
                   {
                       checkbox.checked = true;
                       me.counter++;
                   }
                   if (me.inProgress) ya.next(ya.host);
                   return;
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка на вылет из индекса (GS)
// -----------------------------------------------

sape.toolbar.seobudget.gs = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, google = st.google, me = google.gs;

    var host  = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
    var hlink = 'http://' + host + '/';
    var data  = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=sindex&engine=google&param1[]=' + st.safeEncode(hlink);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                   requestTimer.cancel();

                   var result = req.responseText;
                   if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
                   {
                        if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                        me.inProgress = 0;
                        crow.removeAttribute('gs');
                        return;
                   }
                   if (result.match(/BAD UID OR HAVE NO MONEY/i))
                   {
                        if (me.inProgress) st.showAlert(st.str('bad'), st.str('seobudget.inc.login'), 2);
                        me.inProgress = 0;
                        crow.removeAttribute('gs');
                        return;
                   }
                   var cnt = parseInt(result, 10);
                   if (cnt == 0)
                   {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");
                        if (!(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                        if (st.google.icache) st.cache.push(hlink, 'gs', 0);
                   }
                   if (cnt > 0)
                   {
                       place.setAttribute("style", "color:white !important; background-color:green !important;");
                       if (st.google.icache) st.cache.push(hlink, 'gs', cnt);
                   }
                   if (me.showcounters && (cnt !== -1))
                   {
                       var col = crow.getElementsByTagName('td');
                       st.google.placeCounter(col[me.lc], cnt);
                   }
                   if (cnt == -1)
                   {
                       place.setAttribute("style", "color:white !important; background-color:silver !important;");
                       if (ya.errcheck && !(checkbox.checked))
                       {
                           checkbox.checked = true;
                           me.counter++;
                       }
                   }
                   if (me.inProgress) google.next(google.gs);
                   return;
            }
            else
            {
                   requestTimer.cancel();
                   place.setAttribute("style", "color:white !important; background-color:silver !important;");
                   if (ya.errcheck && !(checkbox.checked))
                   {
                       checkbox.checked = true;
                       me.counter++;
                   }
                   if (me.inProgress) google.next(google.gs);
                   return;
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data)} catch(e) {req.abort()}
};

// -----------------------------------------------
// Проверка уникальности контента
// -----------------------------------------------

sape.toolbar.seobudget.uniq =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/seobudget.png",
};

sape.toolbar.seobudget.uniq.next = function()
{
      var st = sape.toolbar, me = st.seobudget.uniq;
      if (me.inProgress) st.setTimer(me.nextone, (arguments.length)? arguments[0] : 250);
};

sape.toolbar.seobudget.uniq.show = function(place, count)
{
      var st = sape.toolbar, me = st.seobudget.uniq;

      var b = me.doc.createElement('b');
          b.style.color = 'green';
          b.style.cursor = 'help';
          b.title = sape.toolbar.str('seobudget.unique');
          b.textContent = 'Q:\xA0';

      if (count == 'n/a')
      {
          b.title = sape.toolbar.str('seobudget.unique.no');
      }
      else
      {
          if (parseInt(count, 10) < me.limit) b.style.color = 'red';
      }
      place.appendChild(me.doc.createTextNode(' '));
      place.appendChild(b);
      place.appendChild(me.doc.createTextNode('[' + count + ']'));
};

sape.toolbar.seobudget.uniq.run = function(link, place, crow)
{
    var st = sape.toolbar, me = st.seobudget.uniq;
    var data  = 'uid=' + st.seobudget.uid + '&pid=' + st.seobudget.pid + '&action=punique&param1[]=' + st.safeEncode(link);

    var loader = me.doc.createElement("img");
        loader.src = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

    if  (crow.hasAttribute("unique")) return;
    else crow.setAttribute("unique", 1);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (loader) place.removeChild(loader);

            if (req.status == 200 && req.responseText.length)
            {
                   var result = req.responseText;
                   if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i) || result.match(/BAD UID OR HAVE NO MONEY/i))
                   {
                        if (me.inProgress)
                        {
                            if (result.match(/BAD UID/i)) st.showAlert(st.str('bad'), st.str('seobudget.inc.login'), 2);
                            else                          st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2);
                        }
                        me.inProgress = 0;
                        crow.removeAttribute('unique');
                        return;
                   }
                   me.show(place, result.toString() + '%');
                   if (me.icache) st.cache.push(link, 'unique', result.toString() + '%');
                   if (me.checkit && parseInt(result, 10) < me.limit)
                   {
                        var col = crow.getElementsByTagName('td');
                        var box = col[me.lay.check].getElementsByTagName('input');

                        box[0].checked = true;
                   }
                   me.next(100);
            }
            else
            {
                   me.show(place, 'n/a');
                   if (me.icache) st.cache.push(link, 'unique', 'n/a');
                   me.next(100);
            }
        }
    }
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);

    place.appendChild(loader);
    try {req.send(data)} catch(e) {req.abort()}
};

sape.toolbar.seobudget.uniq.nextone = function()
{
      var st = sape.toolbar, me = st.seobudget.uniq;
      if (!me.inProgress) return;

      var row = me.doc.getElementsByTagName('tr');
      if (me.doc.defaultView) for (var i=0; i < row.length; i++)
      {
        if (row[i].hasAttribute('unique')) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var link  = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(link)) continue;

        var place = st.getPlace(col[me.lc]);
        var crow = row[i];

        if (me.icache)
        {
            var _cache = st.cache.pop(link, 'unique');
            if (_cache !== null)
            {
                crow.setAttribute("unique", 1);
                me.show(place, _cache);
                if (me.checkit && (_cache !== 'n/a') && (parseInt(_cache, 10) < me.limit)) box[0].checked = true;
                continue;
            }
        }
        me.run(link, place, crow);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('ya.finish'), 2, me.img);
    }
};

sape.toolbar.seobudget.uniq.unload = function()
{
    var me = sape.toolbar.seobudget.uniq;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.seobudget.uniq.start = function()
{
    var st = sape.toolbar, me = st.seobudget.uniq;
    if (!st.inside(content.document)) return;

    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    st.seobudget.init();
    me.doc = content.document;

    var lay = st.layout(me.doc);
    me.lc   = (lay.url == -1)? lay.link : lay.url;
    me.lay  = lay;

    if (me.lc < 0) return;

    var prefs  = st.prefs();
    me.icache  = prefs.getBoolPref("cache");
    me.checkit = prefs.getBoolPref("seobudget.unique.check");
    me.limit   = prefs.getIntPref("seobudget.unique.limit");

    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    for (var i=0; i < 3; i++) me.next(500 * (i+1));
}