if (!sape) var sape={};
if (!sape.updates) sape.updates = {lastup:0, now:0, up:''};

sape.updates.show = function()
{
    try
    {
        var notifyBox = gBrowser.getNotificationBox();
        if (notifyBox)
        {
            var notify = notifyBox.getNotificationWithValue('yandex-updates-popup');
            if (!notify)
            {
                notify = notifyBox.appendNotification(sape.toolbar.str('attention') + ' ' + sape.toolbar.str('updates.warning') + ' (' + sape.updates.up + ')', 'yandex-updates-popup', 'chrome://wmsape/skin/yandex.png', notifyBox.PRIORITY_WARNING_LOW, null);
                notify.setAttribute("tooltiptext", sape.toolbar.str('close'));
                notify.addEventListener("click", sape.updates.onClick);
            }
        }
    } catch(err){}
};

sape.updates.onClick = function(aEvent)
{
    aEvent.target.close();
};

sape.updates.get = function()
{
    var self = sape.updates, D = new Date();
    self.now = Math.round(D.getTime() / 1000) + ((D.getTimezoneOffset() + 240) * 60);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', 'http://seobudget.ru/downloads/updates.xml?' + self.now, true);
        req.overrideMimeType('text/xml; charset=utf-8');

    req.onreadystatechange = function(aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseXML)
            {
                var dates  = req.responseXML.getElementsByTagName("date");
                for (var j=0; j < dates.length; j++)
                {
                    if (dates[j].parentNode.getAttribute("id") != "serp") continue;

                    var stamp = parseInt(dates[j].getAttribute("timestamp"), 10);
                    if (stamp > self.lastup)
                    {
                        self.lastup = stamp;
                        self.up = dates[j].textContent;
                    }
                    if ((self.now - self.lastup) < 12 * 60 * 60) self.show();
                }
            }
        }
    }
    req.send(null);
};

sape.updates.check = function()
{
    var self = sape.updates;
    if (!self.lastup) return self.get();

    var D = new Date(), now = Math.round(D.getTime() / 1000) + ((D.getTimezoneOffset() + 240) * 60);

    if ((now - self.lastup) < 12 * 60 * 60) return self.show();
    if ((now - self.now)    >  1 * 60 * 60) return self.get();
};