if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

if (!sape.toolbar.ya) sape.toolbar.ya =
{
    timeout: 500,
    yandexcheck: 0,
    skip: false,
    icache: true,
    errcheck: false,
    seobudget: false,
    antigate: '',
    changeselect: true,
    img: "chrome://wmsape/skin/yandex.png",
};

sape.toolbar.ya.init = function()
{
    var st = sape.toolbar, ya = st.ya;
    var prefs = st.prefs();

    ya.skip         = prefs.getBoolPref("re.check");
    ya.icache       = prefs.getBoolPref("cache");
    ya.errcheck     = prefs.getBoolPref("errors.check");
    ya.seobudget    = prefs.getBoolPref("seobudget.use");
    ya.changeselect = prefs.getBoolPref("changeselect");
    ya.antigate     = prefs.getCharPref("antigate.api").replace(/(^\s+)|(\s+$)/, '');
    ya.yandexcheck  = Math.min(6,   prefs.getIntPref("yandexcheck"));
    ya.timeout      = Math.max(250, prefs.getIntPref("timeout.yandex"));
    ya.defaultURL   = 'http://yandex.ru/yandsearch?lr=1&text=';
    ya.requestURL   = st.ya.defaultURL;

    if (!ya.seobudget)
    {
        if (ya.yandexcheck == 6) ya.requestURL = 'http://yandex.com/yandsearch?lr=87&text=';
        if (ya.yandexcheck == 5) ya.requestURL = 'http://yandex.by/yandsearch?lr=157&text=';
        if (ya.yandexcheck == 4) ya.requestURL = 'http://yandex.ua/yandsearch?lr=143&text=';
        if (ya.yandexcheck == 3) ya.requestURL = 'http://search.tut.by/?status=1&ru=1&encoding=1&page=0&how=rlv&query=';
        if (ya.yandexcheck == 2) ya.requestURL = 'http://yandex.ru/familysearch?lr=1&text=';
    }
    else
    {
        ya.yandexcheck = 0;
        st.seobudget.init();
    }
    if (ya.yandexcheck == 1) st.xml.init();
    if (ya.antigate) sape.antigate.API = ya.antigate;
    if (prefs.getBoolPref("yandex.updates")) sape.updates.check();
};

sape.toolbar.ya.stop = function(me)
{
    if (me.inProgress || me.cTimer)
    {
        me.cTimer = 0;
        me.inProgress = 0;

        return true;
    }
    else
        return false;
};

sape.toolbar.ya.isCaptcha = function(req)
{
   if (req.channel.URI.host.indexOf('captcha.yandex') > -1)      return 1;
   if (req.channel.URI.path.indexOf('showcaptcha') > -1)         return 1;
   if (req.responseText.indexOf('captcha.yandex.net')  > -1)     return 1;

   if (/yandex\.(ru|com|by|ua)\/captchaimg/.test(req.responseText)) return 1;
   return 0;
};

sape.toolbar.ya.anticaptcha = function(me, req)
{
    var st = sape.toolbar;
    if (me.inProgress)
    {
        me.inProgress = 0;

        if (st.ya.antigate)
        {
            me.cTimer = 1;
            st.showAlert(st.str('ag.wait'), st.str('captcha'), 3, st.ya.img);
            sape.antigate.addTask(me, req);
        }
        else st.showAlert(st.str('ya.stop'), st.str('captcha'), 2, st.ya.img);
    }
};

sape.toolbar.ya.countIndex = function(text)
{
    var c, exp = /(Знайш|Наш|has\sfound)[^0-9]+([0-9]+[^\n<]*)[^а-я\n]*(ответ|страниц|відповід|адказ|answer)/i;  // ya

    if (c = exp.exec(text))
    {
        var count = parseInt(c[2].replace(/[^0-9]/g, ''), 10);
        if (c[2].indexOf('тыс') != -1 || c[2].indexOf('тис') != -1     || c[2].indexOf('thousand') != -1) count = count * 1000;
        if (c[2].indexOf('млн') != -1 || c[2].indexOf('миллион') != -1 || c[2].indexOf('million') != -1)  count = count * 1000000;

        return count;
    }
    if ((text.indexOf('Искомая комбинация слов нигде не встречается')    != -1) ||
        (text.indexOf('К сожалению по вашему запросу ничего не найдено') != -1) ||
        (text.indexOf('there are no results for this search')            != -1) ||
        (text.indexOf('Шуканая камбiнацыя слоў нiдзе не сустракаецца')   != -1) ||
        (text.indexOf('Патрэбная камбінацыя слоў нідзе не сустракаецца') != -1) ||
        (text.indexOf('Шукана комбінація слів ніде не зустрічається')    != -1)) return 0;

    return -1;
};

sape.toolbar.ya.inIndex = function(text)
{
    var result = sape.toolbar.ya.countIndex(text);
    if (!result) return 404;

    if (result < 0) return 0;
    if (result > 0) return 200;
};

sape.toolbar.ya.next = function(me)
{
      var st = sape.toolbar;
      var timeout = (arguments.length > 1)? arguments[1] : st.ya.timeout + Math.round(st.ya.timeout * Math.random());

      if (me.doc && me.inProgress) st.setTimer(me.nextone, timeout);
};

// -----------------------------------------------
// Проверка на вылет из индекса (HOST)
// -----------------------------------------------
if (!sape.toolbar.ya.host) sape.toolbar.ya.host =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    idx: 0,
    counter: 0,
    showcounters: false,
    regionCheck: false,
    regionNumber: 0,
    lay: {},
    cTimer: null,
};

sape.toolbar.ya.host.placeCounter = function(place, count)
{
    var b = place.ownerDocument.createElement('b');
        b.className = 'not-blocked-in-yandex';
        b.appendChild(place.ownerDocument.createTextNode('Я:'));

    var s  = place.ownerDocument.createTextNode(" [" + count + "]\xA0");
    var sp = place.ownerDocument.createTextNode(" ");

    var e = place.getElementsByTagName('b');
    for (var i=0; i < e.length; i++)
    {
        if (e[i].className == 'blocked-in-yandex')
        {
            e[i].className = 'not-blocked-in-yandex';
            e[i].textContent = 'Я:';
            e[i].parentNode.insertBefore(s, e[i].nextSibling);
            return;
        }
        if (e[i].className == 'not-blocked-in-yandex' && e[i].nextSibling)
        {
            e[i].nextSibling.textContent = " [" + count + "]\xA0";
            return;
        }
    }
    place.appendChild(sp);
    place.appendChild(b);
    place.appendChild(s);
};

sape.toolbar.ya.host.query = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.host;

    var host  = link.split("/")[2].replace(/^www\./i, '');
    var q     = 'host:"' + host + '" | host:"www.' + host + '"';
    var url   = ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');
    var clink = 'http://' + host + '/';

    if (me.regionCheck)
    {
        if (ya.yandexcheck > 2)
        {
            url = ya.defaultURL + st.safeEncode(q);
        }
        url = url.replace('?lr=1&', '?') + '&rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
        clink += '++' + me.regionNumber;
    }
    place.setAttribute('href', url);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.setRequestHeader('Referer', 'http://yandex.ru/');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();

            if (ya.isCaptcha(req))
            {
                if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.host, req);
                crow.removeAttribute('host');
                return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                    var result = req.responseText;
                    var is = ya.countIndex(result);
                    if (is == 0)
                    {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");
                        if (!(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }
                    if (is > 0)
                    {
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                    }
                    if (is > -1)
                    {
                        if (ya.icache) st.cache.push(clink,  'host.' + ya.yandexcheck, is);
                        if (me.showcounters)
                        {
                            var col = crow.getElementsByTagName('td');
                            me.placeCounter(col[me.lc], is);
                        }
                    }
                    if (is == -1)
                    {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }
            }
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                if (ya.errcheck && !(checkbox.checked))
                {
                    checkbox.checked = true;
                    me.counter++;
                }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
    if (me.inProgress) ya.next(ya.host);
};

sape.toolbar.ya.host.nextone = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.host;

    if (!me.doc) return;
    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('host') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_host') < 0) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (box[0].checked && ya.skip) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className.indexOf('icon_host') != -1) as = ai[j];
        }
        if (!as) continue;

        var href  = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var host = href.split("/")[2].replace(/^www\./i, '').toLowerCase();
        var link = 'http://' + host + '/';
        var cache_link = link;

        if (me.regionCheck) cache_link += '++' + me.regionNumber;
        if (ya.icache)
        {
            var ycount = st.cache.pop(cache_link, 'host.' + ya.yandexcheck);
            if (ycount !== null)
            {
                if (ycount > 0)
                {
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                }
                if (ycount == 0)
                {
                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(box[0].checked))
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                row[i].setAttribute('host', '1');

                if (me.showcounters) me.placeCounter(col[me.lc], ycount);
                continue;
            }
        }
        row[i].setAttribute('host', '1');

        if (ya.seobudget && !me.regionCheck) st.seobudget.host(link, as, box[0], row[i]);
        else
        {
            if (ya.yandexcheck == 1) st.xml.host(link, as, box[0], row[i]);
            else                     me.query(link, as, box[0], row[i]);
        }
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, st.ya.img);
    }
};

sape.toolbar.ya.host.unload = function()
{
    var me = sape.toolbar.ya.host;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.ya.host.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.host;
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, st.ya.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var lay    = st.layout(doc);
    me.lay     = lay;
    me.doc     = doc;
    me.idx     = lay.idx;
    me.lc      = (lay.url < 0)? lay.link : lay.url;;
    me.counter = 0;
    me.cTimer  = 0;
    ya.init();

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs = st.prefs();
    me.showcounters = (lay.black)? false : prefs.getBoolPref("showcounters.yandex");
    me.regionCheck  = prefs.getBoolPref("region.check");
    me.regionNumber = prefs.getIntPref("region.number");

    if (me.lc < 0) return;

    // Расставляем кнопки
    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('host') == '1') continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < lay.cols) continue;

        var box = col[lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var host = href.split("/")[2].replace(/^www\./i, '').toLowerCase();
        var link = 'http://' + host + '/';
        var q = 'host:"' + host + '" | host:"www.' + host + '"';

        var url = ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');
        var cache_link = link;

        if (me.regionCheck)
        {
            if (ya.yandexcheck > 2)
            {
                url = ya.defaultURL + st.safeEncode(q);
            }
            url = url.replace('?lr=1&', '?') + '&rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
            cache_link += '++' + me.regionNumber;
        }

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
            if (ai[j].className.match(/icon_host/)) as = ai[j];
        }

        if (as)
        {
            as.href = url;
            continue;
        }
        else
        {
            as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_host icon_yal';
            as.appendChild(me.doc.createTextNode('HOST'));
        }

        if (ya.icache)
        {
            var ycount = st.cache.pop(cache_link, 'host.' + ya.yandexcheck);
            if (ycount !== null)
            {
                if (ycount > 0)
                {
                        row[i].setAttribute('host', '1');
                        as.setAttribute("style", "color:white !important; background-color:green !important;");
                }
                if (ycount == 0)
                {
                        row[i].setAttribute('host', '1');
                        as.setAttribute("style", "color:white !important; background-color:red !important;");
                        if (box && !(box[0].checked))
                        {
                            box[0].checked = true;
                            me.counter++;
                        }
                }
            }
        }
        var ai = col[me.lay.ico].getElementsByTagName('a'), ico = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className.match(/icon_/))
             {
                 ico = ai[j]; break;
             }
        }

        if (ico)
        {
            if (me.lay.ico == me.lc && j < me.idx) return;
            ico.parentNode.insertBefore(as, ico.nextSibling);
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";
            div.style.marginLeft = (lay.black)? "25px" : "0px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }

        if (me.showcounters && ya.icache)
        {
            if (ycount !== null)
            {
                me.placeCounter(col[me.lc], ycount);
            }
            else row[i].removeAttribute('host');
        }
    }
    st.initDOM();

    st.showAlert(st.str('nice'), st.str('ya.start'), 1, st.ya.img);
    me.inProgress = 1;

    if ((ya.seobudget && !me.regionCheck) || ya.yandexcheck == 1)
    {
        for (var i=1; i < 4; i++) ya.next(ya.host, 500 * i);
    }
    else ya.next(ya.host, 500);
};

// -----------------------------------------------
// Проверка проиндексированности страницы (YAP)
// -----------------------------------------------

if (!sape.toolbar.ya.yap) sape.toolbar.ya.yap =
{
    doc: null,
    inProgress: 0,
    lc: -1,
    idx: 0,
    counter: 0,
    lay: {},
    cTimer: null,
    history:
    {
      use: false,
      age: 3,
    },
};

sape.toolbar.ya.yap.query = function(link, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.yap;

    var page       = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q          = 'url:"' + page + '" | url:"www.' + page + '"';
    var url        = ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');
    var age        = st.cache.age(link, 'history');

    place.setAttribute('href', url);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.setRequestHeader('Referer', 'http://yandex.ru/');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (ya.isCaptcha(req))
            {
                if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.yap, req);
                crow.removeAttribute('yap');
                return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                    var result = req.responseText;
                    var is = ya.inIndex(result);
                    if (is == 404)
                    {
                        if (!age && me.lay.history) st.cache.push(link, 'history', 404);
                        if (age) place.setAttribute("title", st.str('yap.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                        place.setAttribute("style", "color:white !important; background-color:red !important;");
                        if (ya.icache) st.cache.push(link, 'yap.' + ya.yandexcheck, 404);
                        if (!(checkbox.checked) && ((age <= me.history.age) && me.history.use))
                        {
                            place.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                        }
                        if (!(checkbox.checked) && ((age > me.history.age) || !me.history.use))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }
                    if (is == 200)
                    {
                        st.cache.del(link, 'history');
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        if (ya.icache)
                        {
                            var host  = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
                            var lhost = 'http://' + host + '/';

                            st.cache.push(link,  'yap.' + ya.yandexcheck, 200);

                            var yc = ya.yac.getCacheLink(result);
                            if (yc) st.cache.push(link,  'yac', yc);
                        }
                    }
                    if (!is)
                    {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }
            }
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                if (ya.errcheck && !(checkbox.checked))
                {
                    checkbox.checked = true;
                    me.counter++;
                }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
    if (me.inProgress) ya.next(ya.yap);
};

sape.toolbar.ya.yap.nextone = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.yap;

    if (!me.doc) return;
    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('yap') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_yap') < 0) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (box[0].checked && ya.skip) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < 1) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className.indexOf('icon_yap') != -1) as = ai[j];
        }
        if (!as) continue;

        var href  = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link  = href;
        var age   = st.cache.age(link, 'history');

        if (ya.icache)
        {
            var value = st.cache.pop(link, 'yap.' + ya.yandexcheck);
            if (value)
            {
                if (value == 200)
                {
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                }
                if (value == 404)
                {
                    if (age) as.setAttribute("title", st.str('yap.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(box[0].checked) && ((age <= me.history.age) && me.history.use))
                    {
                        as.setAttribute("style", "color:white !important; background-color:#FF66 !important;");
                    }
                    if (!(box[0].checked) && ((age > me.history.age) || !me.history.use))
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                row[i].setAttribute('yap', '1');
                continue;
            }
        }
        row[i].setAttribute('yap', '1');

        if (ya.seobudget) st.seobudget.yap(link, as, box[0], row[i])
        else
        {
            if (ya.yandexcheck == 1) st.xml.yap(link, as, box[0], row[i]);
            else                     me.query(link, as, box[0], row[i]);
        }
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('yap.finish'), 2, st.ya.img);
    }
};

sape.toolbar.ya.yap.unload = function()
{
    var me = sape.toolbar.ya.yap;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.ya.yap.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.yap;
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('yap.stop'), 2, st.ya.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var lay = st.layout(doc);
    if (lay.black) return st.ya.host.start();

    var prefs = st.prefs();

    me.doc     = doc;
    me.lay     = lay;
    me.idx     = lay.idx;
    me.lc      = (lay.url < 0)? lay.link : lay.url;;
    me.counter = 0;
    ya.init();

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc < 0) return;
    if (me.lay.loc.indexOf('sape.ru/site_pages.php') > 0 || me.lay.loc.indexOf('/site_pages_context.php') > 0) me.lay.ico = 0;

    me.history.use  = prefs.getBoolPref("history.use") && me.lay.history;
    me.history.age  = prefs.getIntPref("history.age") * 24 * 60 * 60;

    // Расставляем кнопки
    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('yap') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_yap icon_yal') != -1) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < lay.cols) continue;

        var box = col[lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);
        var page = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
        var age  = st.cache.age(link, 'history');

        var q = 'url:"' + page + '" | url:"www.' + page + '"';
        var url = ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_yap icon_yal';
            as.appendChild(me.doc.createTextNode('YAP'));

        var ai = col[me.lay.ico].getElementsByTagName('a'), yap = 0;
        for (var j=0; j < ai.length; j++)
        {
              if (ai[j].className == 'icon_yap')
              {
                  as = ai[j]; as.href = url; as.removeAttribute('onclick');

              }
              if (ai[j].className.match(/icon_/)) yap = ai[j];
        }

        if (ya.icache)
        {
            var value = st.cache.pop(link, 'yap.' + ya.yandexcheck);
            if (value)
            {
                if (value == 200)
                {
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                }
                if (value == 404)
                {
                    if (age) as.setAttribute("title", st.str('yap.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(box[0].checked) && ((age <= me.history.age) && me.history.use))
                    {
                        as.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                    }
                    if (!(box[0].checked) && ((age > me.history.age) || !me.history.use))
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                row[i].setAttribute('yap', '1');
            }
        }
        if (as.className == 'icon_yap') continue;

        if (yap)
        {
            if (me.lay.ico == me.lc && j < me.idx) return;
            yap.parentNode.insertBefore(as, yap.nextSibling);
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }
    }
    st.initDOM();

    st.showAlert(st.str('nice'), st.str('yap.start'), 1, st.ya.img);
    me.inProgress = 1;
    if (ya.seobudget || ya.yandexcheck == 1)
    {
        for (var i=1; i < 4; i++) ya.next(ya.yap, 500 * i);
    }
    else ya.next(ya.yap, 500);
};

// -----------------------------------------------
// Проверка проиндексированности ссылок (YAL)
// -----------------------------------------------

if (!sape.toolbar.ya.yal) sape.toolbar.ya.yal =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    tc: -1,
    idx: 0,
    dc:  0,
    liveDays: 0,
    lastDate: 0,
    counter: 0,
    lay: {},
    cTimer: null,
    history:
    {
      use: false,
      age: 3,
    },
};

sape.toolbar.ya.yal.gettext = function(cell)
{
    var st = sape.toolbar, doc = cell.ownerDocument, result = "", text = "";
    var s = cell.getElementsByTagName('span');

    if (s.length && st.sape(doc))
    {
        for (var i=0; i < s.length; i++)
        {
            if (s[i].className.match(/txt_container|link_text/)) { cell = s[i]; break; }
        }
    }

    var text = cell.innerHTML.replace(/<br.*$/, "").replace(/<p.*$/, "");

    if (st.sape(doc))     text = text.replace(/(<\/?u[^>]*>)/g, '');

    text = text.replace(/<(a|span)[^<]+<\/(a|span)>/g, '')
               .replace(/^[\*\s]*/g, "")
               .replace(/<div.*$/, "")
               .replace(/<br.*$/, "")
               .replace(/<[^<>]+>/g, "");

    text = st.html2text(text, doc);

    text = text.replace(/(\s{2,})/g, " ")
               .replace(/(^\s+)|(\s+$)/g, "");

    return text;
};

sape.toolbar.ya.yal.getquery = function(cell)
{
    var st = sape.toolbar, doc = cell.ownerDocument, parts = [], good = [];
    var s = cell.getElementsByTagName('span');

    if (s.length && st.sape(doc))
    {
        for (var i=0; i < s.length; i++) if (s[i].className.match(/txt_container|link_text/)) cell = s[i];
    }

    var text = cell.innerHTML.replace(/<br.*$/, "").replace(/<p.*$/, "");

    if (st.sape(doc))     parts = text.replace(/(<\/?u[^>]*>)/g, '').split(/([\.\;\!\?]+\s)/);

    while (parts.length)
    {
        var text = parts.shift();
            text = text.replace(/<(a|span)[^<]+<\/(a|span)>/g, '')
                       .replace(/^[\*\s]*/g, "")
                       .replace(/<div.*$/, "")
                       .replace(/<br.*$/, "")
                       .replace(/<[^<>]+>/g, "");

            text = st.html2text(text, doc);

            text = text.replace(/[\-\%\"\+\:\/]+/g, " ")
                       .replace(/(\s{2,})/g, " ")
                       .replace(/(^\s+)|(\s+$)/g, "");

        if (text.length > 2) good.push(text);
    }
    var result = good.join('" && "');
        result = (result.indexOf('&&') > -1)? '("' + result + '")' : '"' + result + '"';

    return result;
};

sape.toolbar.ya.yal.query = function(link, text, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.yal;

    var page  =  link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q     =  text + ' (url:"' + page + '" | url:"www.' + page + '")';
    var url   =  ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');

    place.setAttribute('href', url);

    var host   = link.split("/")[2].replace(/^www\./i, '');
    var hlink  = 'http://' + host + '/';
    var clink  = link + '++' + text;
    var age    = st.cache.age(clink, 'history');

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.setRequestHeader('Referer', 'http://www.yandex.ru/');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();
            if (ya.isCaptcha(req))
            {
                    if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.yal, req);
                    crow.removeAttribute('yal');
                    return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                    var result = req.responseText;

                    var is = ya.inIndex(result);
                    if (is == 404)
                    {
                        if (!age && me.lay.history) st.cache.push(clink, 'history', 404);
                        if (age) place.setAttribute("title", st.str('yal.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                        place.setAttribute("style", "color:white !important; background-color:red !important;");

                        if (!(checkbox.checked) && ((age <= me.history.age) && me.history.use))
                        {
                            place.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                        }
                        if (!(checkbox.checked) && ((age > me.history.age) || !me.history.use))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                        if (ya.icache) st.cache.push(clink, 'yal.' + ya.yandexcheck, 404);
                    }
                    if (is == 200)
                    {
                        st.cache.del(link, 'history');
                        st.cache.del(clink, 'history');
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        if (ya.icache)
                        {
                            st.cache.push(clink, 'yal.' + ya.yandexcheck,  200);
                            st.cache.push(link,  'yap.' + ya.yandexcheck,  200);

                            var yc = ya.yac.getCacheLink(result);
                            if (yc) st.cache.push(link,  'yac', yc);
                        }
                    }
                    if (!is  && !(me.history.use))
                    {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }
            }
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                if (ya.errcheck && !(checkbox.checked) && !(me.history.use))
                {
                    checkbox.checked = true;
                    me.counter++;
                }
            }
       }
    }
    try {req.send(null)} catch(e) {req.abort()}
    if (me.inProgress) ya.next(ya.yal);
};

sape.toolbar.ya.yal.nextone = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.yal;

    if (!me.doc) return;
    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('yal') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_yal') < 0) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (box[0].checked && ya.skip) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < 1) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className.match(/^icon_yal/)) as = ai[j];
        }
        if (!as) continue;

        if (me.liveDays > 0)
        {
            var dateText;
            if (dateText = col[me.dc].innerHTML.match(/([0-9]+)\.([0-9]+)\.([0-9]+)/))
            if (dateText.length > 3)
            {
                var dd = parseInt(dateText[1], 10);
                var mm = parseInt(dateText[2], 10)-1;
                var yy = parseInt(dateText[3], 10);
                if (yy < 2000) yy += 2000;

                var linkDate = new Date(yy,mm,dd);
                if (linkDate > me.lastDate) continue;
            }
        }

        var href  = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link  =  href;
        var text  =  me.getquery(col[me.tc]);
        var clink =  link + '++' + text;
        var age   =  st.cache.age(clink, 'history');

        if (ya.icache)
        {
            var value = st.cache.pop(clink, 'yal.' + ya.yandexcheck);
            if (value)
            {
                if (value == 200)
                {
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                }
                if (value == 404)
                {
                    if (age) as.setAttribute("title", st.str('yal.noindex') + ' (' + (age/3600).toFixed() + 'h)');

                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(box[0].checked) && ((age <= me.history.age) && me.history.use))
                    {
                        as.setAttribute("style", "color:white !important; background-color:#FF6666 !important;");
                    }
                    if (!(box[0].checked) && ((age > me.history.age) || !me.history.use))
                    {
                        box[0].checked = true;
                        me.counter++;
                    }
                }
                row[i].setAttribute('yal', '1');
                continue;
            }
        }
        row[i].setAttribute('yal', '1');

        if (ya.seobudget) st.seobudget.yal(link, me.gettext(col[me.tc]), as, box[0], row[i]);
        else
        {
            if (ya.yandexcheck == 1) st.xml.yal(link, text, as, box[0], row[i]);
            else                     me.query(link, text, as, box[0], row[i]);
        }
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('yal.finish'), 2, st.ya.img);
    }
};

sape.toolbar.ya.yal.unload = function()
{
    var me = sape.toolbar.ya.yal;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.ya.yal.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.yal;
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('yal.stop'), 2, st.ya.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var lay = st.layout(doc);
    if (lay.dc == -1) return;

    var prefs   = st.prefs();

    me.liveDays = prefs.getIntPref("livedays");
    me.lastDate = new Date();
    ya.init();

    me.lastDate.setDate(me.lastDate.getDate() - me.liveDays);

    me.lay = lay;
    me.doc = doc;
    me.idx = lay.idx;
    me.dc  = lay.dc;
    me.tc  = lay.text;
    me.lc  = (lay.link < 0)? lay.url : lay.link;
    me.counter = 0;
    me.inProgress = 1;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.history.use  = prefs.getBoolPref("history.use") && me.lay.history;
    me.history.age  = prefs.getIntPref("history.age") * 24 * 60 * 60;

    // Расставляем кнопки
    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('yal') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_yal icon_yal') != -1) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < lay.cols) continue;

        if (me.liveDays > 0)
        {
            var dateText;
            if (dateText = col[me.dc].innerHTML.match(/([0-9]+)\.([0-9]+)\.([0-9]+)/))
            if (dateText.length > 3)
            {
                var dd = parseInt(dateText[1], 10);
                var mm = parseInt(dateText[2], 10)-1;
                var yy = parseInt(dateText[3], 10);
                if (yy < 2000) yy += 2000;

                var linkDate = new Date(yy,mm,dd);
                if (linkDate > me.lastDate) continue;
            }
        }

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = href;
        var page = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');

        var text = me.getquery(col[me.tc]);

        var q = text + ' (url:"' + page + '" | url:"www.' + page + '")';
        var url = ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_yal icon_yal';
            as.appendChild(me.doc.createTextNode('YAL'));

        var ai = col[me.lay.ico].getElementsByTagName('a'), yap = 0;
        for (var j=0; j < ai.length; j++)
        {
            if (ai[j].className == 'icon_yal')
            {
                as = ai[j]; as.href = url; as.removeAttribute('onclick');
            }
            if (ai[j].className.match(/icon_/)) yap = ai[j];
        }

        if (as.className == 'icon_yal') continue;
        if (yap)
        {
            if (me.lay.ico == me.lc && j < me.idx) return;
            yap.parentNode.insertBefore(as, yap.nextSibling);
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }
    st.initDOM();
    st.showAlert(st.str('nice'), st.str('yal.start'), 1, st.ya.img);

    if (ya.seobudget || ya.yandexcheck == 1)
    {
        for (var i=1; i < 3; i++) ya.next(ya.yal, 500 * (i+1));
    }
    else ya.next(ya.yal, 500);
};

// -----------------------------------------------
// Проверка кэша страниц
// -----------------------------------------------

if (!sape.toolbar.ya.yac) sape.toolbar.ya.yac =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    idx: 0,
    counter: 0,
    lay: {},
    cTimer: null,
};

sape.toolbar.ya.yac.placeCounter = function(place, count)
{
    var b = place.ownerDocument.createElement('b');
        b.className = 'not-blocked-in-yandex yac';
        b.appendChild(place.ownerDocument.createTextNode('YC:'));
        b.title = sape.toolbar.str('yac.date');

    var s = place.ownerDocument.createTextNode("\xA0[" + count + "]\xA0");
    var sp = place.ownerDocument.createTextNode(" ");

    place.appendChild(sp);
    place.appendChild(b);
    place.appendChild(s);
};

sape.toolbar.ya.yac.getDate  = function(text, row)
{
    var st = sape.toolbar, me = st.ya.yac;
    var exp = /(\d+\.\d+\.\d+)\s\[\d+\:\d+\:\d+\]/;
    var m = text.match(exp);
    if (m)
    {
        me.placeDate(m[1].toString(), row);
        return m[1].toString();
    }
    return 0;
};

sape.toolbar.ya.yac.placeDate  = function(cachedate, row)
{
    var st = sape.toolbar, me = st.ya.yac;
    var col = row.getElementsByTagName('td');
    me.placeCounter(col[me.lay.ico], cachedate);
};

sape.toolbar.ya.yac.placeOld  = function(cachedate, as, checkbox)
{
    var st = sape.toolbar, me = st.ya.yac;

    var lastDate = new Date();
        lastDate.setDate(lastDate.getDate() - me.ageLimit);

    var dateText = cachedate.match(/([0-9]+)\.([0-9]+)\.([0-9]+)/);
    if (!dateText || dateText.length < 4) return;

    var dd = parseInt(dateText[1], 10);
    var mm = parseInt(dateText[2], 10)-1;
    var yy = parseInt(dateText[3], 10);

    if (yy < 2000) yy += 2000;

    var pageDate = new Date(yy,mm,dd);
    if (pageDate > lastDate) return;

    var span = as.ownerDocument.createElement('a');
        span.className = 'icon_old icon_yal';
        span.textContent = "OLD";
        span.title = st.str("yac.old");
        span.setAttribute("style", "color:white !important; background-color:red !important; cursor:help; text-decoration:none;");

    as.parentNode.insertBefore(span, as.nextSibling);
    if (!(checkbox.checked))
    {
        checkbox.checked = true;
        me.counter++;
    }
};

sape.toolbar.ya.yac.getCacheLink  = function(text)
{
    var st  = sape.toolbar;
    var res, exp = /<a\s[^>]*\shref\=\"(http[^\"]+)\"/g;
    exp.lastIndex = 0;
    while (res = exp.exec(text))
    {
        var href = st.html2text(res[1], st.ya.yac.doc);
        if (href.indexOf('hghltd.yandex.net') > -1)
        {
            if (st.urlCheck(href)) return st.getURL(href);
        }
    }
    return null;
};

sape.toolbar.ya.yac.checkCache  = function(link, myLink, as, checkbox, crow, page_id)
{
    var st = sape.toolbar, ya = st.ya, me = st.ya.yac;
    var url = as.getAttribute('href');

    if (ya.icache)
    {
        var cachedate = st.cache.pop(link, 'yacd');
        var present   = st.cache.pop(link + '++' + myLink,  'yac');

        // (в кэше есть дата и ссылка) или (есть один из них, а второй проверять не нужно)
        if ((cachedate && present) || (cachedate && !myLink) || (present && !me.showDate))
        {
            if (me.showDate && cachedate)
            {
                me.placeDate(cachedate, crow);
                if (me.ageCheck)
                {
                    if (!myLink || (present == 404)) me.placeOld(cachedate, as, checkbox);
                }
            }
            if (myLink && (present == 200))
            {
                as.textContent = "YAC+";
                as.title = st.str('ext.found');
            }
            return 1;  // обработали из кэша проверок
        }
    }

    var req = new XMLHttpRequest();
        req.open('GET', url, true);

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (ya.isCaptcha(req))
                {
                    if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.yac, req);
                    crow.removeAttribute('yac');
                    return 0;
                }
                if (req.status == 200 && req.responseText.length)
                {
                    var cachedate = '';
                    if (me.showDate)
                    {
                        cachedate = me.getDate(req.responseText, crow);
                        if (ya.icache && cachedate) st.cache.push(link,  'yacd', cachedate);
                        if (me.ageCheck && cachedate && !myLink) me.placeOld(cachedate, as, checkbox);
                        if (cachedate && page_id) st.cache.notify('yacache', page_id, cachedate.toString());
                    }
                    if (myLink)
                    {
                        var srch = 'a href="' + myLink.replace(/&.*$/i, '').replace(/\/$/i, '');
                        var data = st.ext.utClean(req.responseText, 0);
                        if (data.indexOf(srch) > -1)
                        {
                            as.textContent = "YAC+";
                            as.title = st.str('ext.found');
                            if (ya.icache) st.cache.push(link + '++' + myLink,  'yac', 200);
                        }
                        else
                        {
                            if (ya.icache) st.cache.push(link + '++' + myLink,  'yac', 404);
                            if (me.ageCheck && cachedate) me.placeOld(cachedate, as, checkbox);
                        }
                    }
                }
            }
    }
    req.send(null);
    return 0;
};

sape.toolbar.ya.yac.nextone = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.yac;
    var row = me.doc.getElementsByTagName('tr');
    var rl = row.length;

    if (me.doc.defaultView) for (var i = me.first; i < rl; i++)
    {
        if (row[i].getAttribute('yac') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_yac') < 0) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lc + 1) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var checkbox = box[0];
        if (checkbox.checked && ya.skip) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className.match(/^icon_yac/)) as = ai[j];
        }
        if (!as) continue;

        var href  = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var page_id = (a[me.idx].hasAttribute('page_id'))? a[me.idx].getAttribute('page_id') : 0;

        var link = st.getURL(href);
        var page = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');

        var q = 'url:"' + page + '" | url:"www.' + page + '"';
        var url = ya.defaultURL + st.safeEncode(q).replace(/%20/g, '+');

        var myLink = st.getMyLink(me, row[i]);
        var crow = row[i];

        if (ya.icache)
        {
            var clink = st.cache.pop(link, 'yac');
            // это признак 404
            if (clink && (clink == 404))
            {
                    crow.setAttribute('yac', '1');
                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    if (!(checkbox.checked))
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
                    continue;
            }
            // это ссылка
            if (clink && st.urlCheck(clink))
            {
                    crow.setAttribute('yac', '1');
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                    as.setAttribute("href", clink);
                    if (me.showDate || myLink)
                    {
                        if (me.checkCache(link, myLink, as, checkbox, crow, page_id)) continue;
                        else                                                          return ya.next(ya.yac);
                    }
            }
        }

        var req = new XMLHttpRequest();
            req.open('GET', url, true);

        var requestTimer = st.reqTimer(req, 30000);

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (ya.isCaptcha(req))
                {
                    if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.yac, req);
                    crow.removeAttribute('yac');
                    return;
                }
                if (req.status == 200 && req.responseText.length)
                {
                    var is    = ya.inIndex(req.responseText);
                    var clink = me.getCacheLink(req.responseText);

                    // ошибка разбора ответа
                    if (!is)
                    {
                        as.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }

                    // страницы нет в индексе или нет ссылки на сохраненную копию
                    if (is == 404 || !clink)
                    {
                        as.setAttribute("style", "color:white !important; background-color:red !important;");
                        if (ya.icache)
                        {
                            if (is == 404) st.cache.push(link, 'yap.' + ya.yandexcheck, 404);
                            st.cache.push(link, 'yac', 404);
                        }
                        if (!(checkbox.checked))
                        {
                            checkbox.checked = true;
                            me.counter++;
                        }
                    }

                    // страница в индексе и есть ссылка на сохраненную копию
                    if (is == 200 && clink)
                    {
                        as.setAttribute("style", "color:white !important; background-color:green !important;");
                        as.setAttribute("href", clink);
                        if (ya.icache)
                        {
                            st.cache.push(link,  'yac',  clink);
                        }
                        // есть купленная или надо проверить дату
                        if (me.showDate || myLink)
                        {
                            me.checkCache(link, myLink, as, checkbox, crow, page_id);
                        }
                    }
                }
                // ответ отработан, проверяем следующую
                ya.next(ya.yac);
            }
        }
        crow.setAttribute('yac', '1');
        req.send(null);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, st.ya.img);
    }
};

sape.toolbar.ya.yac.unload = function()
{
    var me = sape.toolbar.ya.yac;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.ya.yac.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.yac;
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, st.ya.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs   = st.prefs();
    var lay     = st.layout(doc);

    me.doc       = doc;
    me.lay       = lay;
    me.lc        = (lay.url < 0)? lay.link : lay.url;
    me.seo       = lay.seo;
    me.idx       = lay.idx;
    me.counter   = 0;
    me.first     = 0;
    me.showDate  = prefs.getBoolPref('yac.check.date');
    me.ageCheck  = prefs.getBoolPref('yac.check.age');
    me.ageLimit  = prefs.getIntPref('yac.age');
    ya.init();

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc < 0) return;

    // Расставляем кнопки
    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('yac') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_yac') != -1) continue;

        var col = row[i].getElementsByTagName('td');
        if (col.length < me.lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.idx + 1) continue;

        var href = a[me.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;
        if (!me.first) me.first = i;

        var link = st.getURL(href);
        var page = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');

        var q = 'url:"' + page + '" | url:"www.' + page + '"';
        var url = ya.defaultURL + st.safeEncode(q).replace(/%20/g, '+');

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_yac icon_yal';
            as.textContent = "YAC";

        var ai = col[me.lay.ico].getElementsByTagName('a'), yap = 0;
        for (var j=0; j < ai.length; j++)
        {
          if (ai[j].className.match(/icon_/))    yap = ai[j];
          if (ai[j].className.match(/icon_yap/)) break;
        }

        if (yap)
        {
          if (me.lay.ico == me.lc && j < me.idx) return;
          yap.parentNode.insertBefore(as, yap.nextSibling);
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }
    st.initDOM();

    st.showAlert(st.str('nice'), st.str('ya.start'), 1, st.ya.img);
    me.inProgress = 1;

    ya.next(ya.yac, 100);
};

// -----------------------------------------------
// Проверка релевантности анкоров
// -----------------------------------------------

if (!sape.toolbar.ya.relevancy) sape.toolbar.ya.relevancy =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    tc: -1,
    seo: 0,
    lay: {},
    idx: 0,
    counter: 0,
    cTimer: null,
};

sape.toolbar.ya.relevancy.anchor = function(cell)
{
    var st = sape.toolbar, doc = cell.ownerDocument, text = cell.innerHTML;
    var s = cell.getElementsByTagName('span');

    if (s.length && st.sape(doc))
    {
        for (var i=0; i< s.length; i++)
        {
            if (s[i].className.match(/txt_container|link_text/)) { text = s[i].innerHTML; break }

            var p = s[i].getElementsByTagName('p');
            if (p.length) { text = s[i].innerHTML.replace(/<p[^>]+>(.*)<\/p>/, ''); break; }
        }
    }
    var result = text.toLowerCase();
    if (st.sape(doc))
    {
        result = result.replace(/<span[^>]+>[^>]+<\/span>(\&nbsp\;)?/g, "")
                       .replace(/[\n\r\f]*/g, '')
                       .replace(/<br.*$/g, '')
                       .replace(/<p.*$/, "")
                       .replace(/^.*<u>/g, '')
                       .replace(/<\/u>.*$/g, '')
                       .replace(/<[^>]+>/ig, '')
                       .replace(/^[\*\s]*/g, '')
                       .replace(/\&[a-z]+\;/g, ' ')
                       .replace(/[^0-9a-zа-яё]+/gi, ' ')
                       .replace(/\s\s/g, ' ')
                       .replace(/(^\s+)|(\s+$)/g, "");
    }
    if (st.ya.relevancy.seo)
    {
        result = result.replace(/\s[0-9a-zа-яё]{1,2}\s/ig, ' ')
                       .replace(/\s[0-9a-zа-яё]{1,2}$/ig, '')
                       .replace(/^[0-9a-zа-яё]{1,2}\s/ig, '');

        if (result.match(/[0-9a-zа-яё]{4}/i))
        {
            result = result.replace(/\s[0-9a-zа-яё]{1,3}\s/ig, ' ')
                           .replace(/\s[0-9a-zа-яё]{1,3}$/ig, '')
                           .replace(/^[0-9a-zа-яё]{1,3}\s/ig, '');
        }
        result = '(' + result.replace(/\s/g, ' | ') + ')';
    }
    return result;
};

sape.toolbar.ya.relevancy.query = function(link, text, place, checkbox, crow)
{
    var st = sape.toolbar, ya = st.ya, me = ya.relevancy;

    var clink = place.getAttribute('href');
    var url   = clink;

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.setRequestHeader('Referer', 'http://yandex.ru/');

    var requestTimer = st.reqTimer(req, 30000);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            requestTimer.cancel();

            if (ya.isCaptcha(req))
            {
                    if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.relevancy, req);
                    crow.removeAttribute('relevance');
                    return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                    var clink  = link + "++" + text;
                    var host   = link.split("/")[2].replace(/^www\./i, '').toLowerCase();
                    var hlink  = 'http://' + host + '/';
                    var result = req.responseText;

                    var is = ya.inIndex(result);
                    if (is == 404)
                    {
                        place.setAttribute("style", "color:white !important; background-color:red !important;");
                        place.title = st.str('rel.bad');
                        checkbox.checked = true;
                        if (ya.icache) st.cache.push(clink, 'yal.' + ya.yandexcheck, 404);
                    }
                    if (is == 200)
                    {
                        place.setAttribute("style", "color:white !important; background-color:green !important;");
                        place.title = st.str('rel.ok');
                        if (ya.icache)
                        {
                            st.cache.push(clink, 'yal.' + ya.yandexcheck,  200);
                            st.cache.push(link,  'yap.' + ya.yandexcheck,  200);

                            var yc = ya.yac.getCacheLink(result);
                            if (yc) st.cache.push(link,  'yac', yc);
                        }
                    }
                    if (!is)
                    {
                        place.setAttribute("style", "color:white !important; background-color:silver !important;");
                        if (ya.errcheck && !(checkbox.checked))
                        {
                            place.checked = true;
                            me.counter++;
                        }
                    }
            }
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                if (ya.errcheck && !(checkbox.checked))
                {
                    checkbox.checked = true;
                    me.counter++;
                }
            }
        }
    }
    try {req.send(null)} catch(e) {req.abort()}
    if (me.inProgress) ya.next(ya.relevancy);
};

sape.toolbar.ya.relevancy.nextone = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.relevancy;

    if (!me.doc) return;
    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('relevance') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_relevance') < 0) continue;

        var col = row[i].getElementsByTagName('td');
        var box = col[me.lay.check].getElementsByTagName('input');

        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;
        if (box[0].checked && ya.skip) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < 1 && (me.lay.loc.indexOf('link_texts') == -1)) continue;

        var ai = col[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className.indexOf('icon_relevance') != -1) as = ai[j];
        }
        if (!as) continue;

        var link = '';
        if (me.lay.loc.indexOf('link_texts') > -1)
        {
            var h = st.getMyLink(me, row[i]);
            if (h) link = h;
        }
        else
        {
            link = a[me.lay.idx].getAttribute('href');
        }
        if (!st.urlCheck(link)) continue;

        var text       = me.anchor(col[me.tc]);
        var cache_link = link + "++" + text;

        if (ya.icache)
        {
            var value = st.cache.pop(cache_link, 'yal.' + ya.yandexcheck);
            if (value != null)
            {
                if (value == 200)
                {
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                    as.title = st.str('rel.ok');
                }
                if (value == 404)
                {
                    box[0].checked = true;
                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    as.title = st.str('rel.bad');
                }
                row[i].setAttribute('relevance', '1');
                continue;
            }
        }
        row[i].setAttribute('relevance', '1');
        try
        {
            if (ya.yandexcheck == 1) st.xml.relevancy(link, text, as, box[0], row[i]);
            else                     me.query(link, text, as, box[0], row[i]);
        }
        catch(e){}
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('rel.finish'), 2, st.ya.img);
    }
};

sape.toolbar.ya.relevancy.unload = function()
{
    var me = sape.toolbar.ya.relevancy;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.ya.relevancy.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.relevancy;
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('rel.stop'), 2, st.ya.img);
        return;
    }
    if (me.doc) me.unload();

    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs     = st.prefs();
    var lay       = st.layout(doc);

    me.lay        = lay;
    me.tc         = lay.text;
    me.lc         = (lay.url < 0)? lay.link : lay.url;
    me.seo        = lay.seo;
    me.doc        = doc;
    me.counter    = 0;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc + me.tc < 0) return;
    ya.init();

    // Расставляем кнопки
    var row = doc.getElementsByTagName('tr');
    var myLink = '';

    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('relevance') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_relevance') > 0) continue;

        var col = row[i].getElementsByTagName('td');
            if (col.length < lay.cols) continue;

        var box = col[lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;
        if (!st.boxCheck(box[0])) continue;

        var href = '';
        if (me.lay.loc.indexOf('link_texts') > -1)
        {
            if (!myLink) myLink = st.getMyLink(me, row[i]);
            if  (myLink) href = myLink;
        }
        else
        {
            var a = col[me.lc].getElementsByTagName('a');
                if (a.length < lay.idx + 1) continue;

            href = a[lay.idx].getAttribute('href');
        }
        if (!st.urlCheck(href)) continue;

        var link = href;
            href = href.replace(/^http[^\/]+[\/]+/i, '').replace(/^www\./i, '').replace(/\/$/, '');

        var text = me.anchor(col[me.tc]);
        var cache_link = link + "++" + text;

        var q = text + ' (url:"' + href + '" | url:"www.' + href + '")';
        var url = ya.requestURL + st.safeEncode(q).replace(/%20/g, '+');

        var as = me.doc.createElement('a');
            as.href = url;
            as.target = '_blank';
            as.className = 'icon_relevance icon_yal';
            as.appendChild(me.doc.createTextNode('REL'));

        if (ya.icache)
        {
            var value = st.cache.pop(cache_link, 'yal.' + ya.yandexcheck);
            if (value != null)
            {
                if (value == 200)
                {
                    as.setAttribute("style", "color:white !important; background-color:green !important;");
                    as.title = st.str('rel.ok');
                }
                if (value == 404)
                {
                    as.setAttribute("style", "color:white !important; background-color:red !important;");
                    as.title = st.str('rel.bad');
                    box[0].checked = true;
                }
                row[i].setAttribute('relevance', '1');
            }
        }

        var ai = col[me.lay.ico].getElementsByTagName('a'), yap = 0;
        for (var j=0; j < ai.length; j++)
        {
          if (ai[j].className.match(/icon_/)) yap = ai[j];
        }

        if (yap)
        {
            if (me.lay.ico == me.lc && j < me.idx) return;
            yap.parentNode.insertBefore(as, yap.nextSibling);
        }
        else
        {
            var div = me.doc.createElement('div');
            div.style.marginTop = "2px";
            div.style.marginBottom = "4px";

            div.appendChild(as);
            col[me.lay.ico].appendChild(div);
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }
    st.initDOM();

    st.showAlert(st.str('nice'), st.str('rel.start'), 1, st.ya.img);
    me.inProgress = 1;

    if (ya.yandexcheck == 1)
    {
        for (var i=1; i < 4; i++) ya.next(ya.relevancy, 500 * i);
    }
    else ya.next(ya.relevancy, 500);
};

//------------------------------------------------------------------------------
// Функция показа ТИЦ
//------------------------------------------------------------------------------

if (!sape.toolbar.ya.tic) sape.toolbar.ya.tic =
{
    doc: null,
    lc: -1,
    tc: -1,
    idx: 0,
    bl: 0,
    bgcolor: "pink",
    check: 0,
    lay: {},
    changeselect: false,
    drivelink: false,
    hosts: [],
};

sape.toolbar.ya.tic.mark = function(aEvent)
{
    var st = sape.toolbar, ya = st.ya, me = ya.tic;
    var doc = content.document;
    var lay = st.layout(doc);

    var image = aEvent.originalTarget;
    var hash  = image.getAttribute('hash');
    if (!hash)
    {
         var cnv = doc.createElement("canvas");
         cnv.width = 88;
         cnv.height = 31;
         cnv.getContext('2d').drawImage(image,0,0,88,31);

         hash = st.md5(cnv.toDataURL("image/png", ""));
         image.setAttribute('hash', hash);
    }
    var row  = doc.getElementsByTagName('tr');
    var counter = 0;
    for (var i=0; i < row.length; i++)
	{
		var img = row[i].getElementsByTagName("img");
        if (img.length == 0) continue;

        var col = row[i].getElementsByTagName("td");
        if (col.length < lay.cols) continue;

        var chk = col[lay.check].getElementsByTagName("input");
        if (chk.length == 0) continue;

        for (var j=0; j < img.length; j++)
        {
            var src = img[j].getAttribute('src');
            if (!src.match(/cycounter|drivelink/)) continue;

            var md5 = img[j].getAttribute('hash');
            if (!md5)
            {
                try
                {
                    var cnv = doc.createElement("canvas");
                    cnv.width = 88;
                    cnv.height = 31;
                    cnv.getContext('2d').drawImage(img[j],0,0,88,31);

                    md5 = st.md5(cnv.toDataURL("image/png", ""));
                    img[j].setAttribute('hash', md5);
                }   catch(e) {}
            }
            if (md5 == hash)
            {
                sape.filters.decorate(row[i], st.ya.tic.bgcolor)
                chk[0].checked = true;
                counter++;
            }
        }
    }
    if (counter > 0)
    {
        st.showAlert(st.str('links.checked') + ' ' + counter, 'fun', 0, "chrome://wmsape/skin/button-13.png");
        var select = sape.filters.getSelect(doc);
        if (me.changeselect && select && st.sape(doc))      select.value = 'placementRemove';
    }
    return false;
};

sape.toolbar.ya.tic.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.tic;

    me.doc = content.document;
    if (!sape.toolbar.inside(me.doc)) return;

    var loc = me.doc.location.href;
    var lay = st.layout(me.doc);

    me.lay = lay;
    me.lc  = (lay.link < 0)? lay.url : lay.link;
    me.tc  = lay.tic;
    me.idx = lay.idx;
    me.bl  = lay.black;
    me.check  = lay.check;

    if (me.tc == -1) me.lc = me.tc = lay.url;
    if (me.tc == -1) return;

    var prefs = st.prefs();

    me.bgcolor      = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
    me.changeselect = prefs.getBoolPref("changeselect");
    me.drivelink    = prefs.getBoolPref("tic.button");

    var rnd = Math.random();
    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
	{
        var drivelink = me.drivelink;

		var td = row[i].getElementsByTagName("td");
        if (td.length < lay.cols) continue;

        var chk = td[me.check].getElementsByTagName("input");
        if (chk.length == 0) continue;
        if (!st.boxCheck(chk[0])) continue;

        var as = td[me.lc].getElementsByTagName('a');
        if (as.length < me.idx + 1) continue;

        var a = as[me.idx].getAttribute('href');
        if (!st.urlCheck(a)) continue;

        var html = row[i].innerHTML;
        if (html.match(/drivelink/) &&  drivelink) drivelink = 0;
        if (html.match(/cycounter/) && !drivelink) drivelink = 1;

        if (html.match(/drivelink/) &&  drivelink) continue;
        if (html.match(/cycounter/) && !drivelink) continue;

        var host  = a.split("/")[2].toLowerCase();

        var img = me.doc.createElement("img");
            img.style.cursor = 'pointer';
            img.addEventListener("click", sape.toolbar.ya.tic.mark, false);

        if (drivelink)
            img.src = 'http://drivelink.ru/images/rank/cache/' + host.replace(/^www./, '') + '.png?r=' + rnd;
        else
            img.src = 'http://yandex.ru/cycounter/?' + host;

        var link = me.doc.createElement("a");

        if (!drivelink) link.href  = 'http://yaca.yandex.ru/yca/cy/ch/' + host + '/';

        var prevent = function(event)
        {
            event.preventDefault();
        }
        link.target = '_blank';
        link.addEventListener("click", prevent,  false);
        link.appendChild(img);

        var div = me.doc.createElement("div");
            div.style.marginTop  = "3px";
            div.style.marginLeft = (me.bl)? "25px" : "0px";
            div.appendChild(link);

        td[me.tc].appendChild(div);
    }
    st.initDOM();
    me.doc = null;
};

//------------------------------------------------------------------------------
// Клей ТИЦ, показ тематики и региона
//------------------------------------------------------------------------------

if (!sape.toolbar.ya.info) sape.toolbar.ya.info =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    tc: -1,
    lay: {},
    cTimer: null,
};

sape.toolbar.ya.info.nextone = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.info;

    if (!me.doc) return;
    var row = me.doc.getElementsByTagName('tr');

    if (me.doc.defaultView) for (var i=0; i < row.length; i++)
    {
        if (row[i].hasAttribute('itic')) continue;

		var col = row[i].getElementsByTagName("td");
        if (col.length < me.lay.cols) continue;

        var chk = col[me.lay.check].getElementsByTagName("input");
        if (!chk.length) continue;
        if (!st.boxCheck(chk[0])) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;


        var host = href.split("/")[2].toLowerCase().replace(/^www\./, '');

        var loader      = me.doc.createElement("img");
            loader.src  = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

        var url = 'http://bar-navig.yandex.ru/u?ver=4.0.0&httpstatus=200&clid=14002&yasoft=barff&url=' + st.urlEncode(href) + '&show=1&post=0&title=' + encodeURIComponent(host);

        var req = new XMLHttpRequest();
            req.open('GET', url, true);

        var requestTimer = st.reqTimer(req, 30000);
        var crow = row[i];

        req.onreadystatechange = function (aEvt)
        {
                if (req.readyState == 4)
                {
                    requestTimer.cancel();

                    if (ya.isCaptcha(req))
                    {
                           if (!me.cTimer) ya.anticaptcha(sape.toolbar.ya.info, req);
                           crow.removeAttribute('itic');
                           col[me.tc].removeChild(loader);
                           return;
                    }
                    if (req.status == 200 && req.responseText.length)
                    {
                            var xml = req.responseXML;
                            var ti  = xml.getElementsByTagName("textinfo");
                            var ui  = xml.getElementsByTagName("url");
                            var ci  = xml.getElementsByTagName("tcy");

                            var info   = (ti.length)? ti[0].textContent : "";
                            var domain = (ui.length)? ui[0].getAttribute("domain").toLowerCase() : "";
                            var tic    = (ci.length)? ci[0].getAttribute("value") : 0;

                            var glue  = null, intext = null;
                            var res   = me.doc.createElement('a');
                            if (!domain.length)
                            {
                                res.setAttribute("style", "color:red; font-weight:bold;");
                                res.appendChild(me.doc.createTextNode('--'));
                                res.href  = 'http://yaca.yandex.ru/yca/cy/ch/' + host + '/';
                            }
                            else
                            {
                               if (domain == host || domain == 'www.' + host)
                               {
                                    res.setAttribute("style", "color:green; cursor:help; font-weight:bold;");
                                    res.title = st.str('ctic.for') + ' ' + domain;
                                    res.href  = 'http://yaca.yandex.ru/yca/cy/ch/' + domain + '/';
                                    res.appendChild(me.doc.createTextNode(tic));
                               }
                               else
                               {
                                    res.setAttribute("style", "color:red; cursor:help; font-weight:bold;");
                                    res.title = st.str('ctic.glue') + ' ' + domain;
                                    res.href  = 'http://yaca.yandex.ru/yca/cy/ch/' + host + '/';
                                    res.appendChild(me.doc.createTextNode('M'));

                                    glue = me.doc.createElement('b');
                                    glue.style.cursor = 'help';
                                    glue.title = st.str('ctic.glue') + ' ' + domain;
                                    glue.appendChild(me.doc.createTextNode(domain));
                               }
                            }
                            col[me.tc].replaceChild(res, loader);

                            if (info.length)
                            {
                                intext = info.replace(/(^[\n\r\s]+)|([\n\r\s]+$)/g, '').replace(/\n/g,  '<br>');
                                intext = intext.replace(/[^<\s>]+\:/ig,  function ($0) {return String($0)[0]+':'} );
                            }
                            if (glue || intext.length)
                            {
                                var place = me.doc.createElement('div');
                                var div = col[me.lc].getElementsByTagName('div');

                                if (div.length)
                                    div[0].parentNode.insertBefore(place, div[0].nextSibling);
                                else
                                    col[me.lc].appendChild(place);
                            }
                            if (glue)                   place.appendChild(glue);
                            if (intext.length)          place.style.margin = "0px 0px 3px 0px";

                            if (glue && intext.length)  place.appendChild(me.doc.createElement('br'));
                            if (intext.length)          place.innerHTML += intext;
                    }
                    else
                    {
                        col[me.tc].removeChild(loader);
                        crow.removeAttribute('itic');
                        return;
                    }
                }
        }
        req.send(null);

        col[me.tc].appendChild(me.doc.createElement('br'));
        col[me.tc].appendChild(loader);

        crow.setAttribute('itic', '1');
        return ya.next(ya.info);
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('ctic.finish'), 2, st.ya.img);
    }
};

sape.toolbar.ya.info.unload = function()
{
    var me = sape.toolbar.ya.info;

    me.cTimer = 0;
    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.toolbar.ya.info.start = function()
{
    var st = sape.toolbar, ya = st.ya, me = ya.info;
    if (ya.stop(me))
    {
        st.showAlert(st.str('bad'), st.str('ctic.stop'), 2, st.ya.img);
        return;
    }
    var doc = content.document;
    if (!st.inside(doc)) return;

    var prefs   = st.prefs();
    ya.timeout  = Math.max(250, prefs.getIntPref("timeout.yandex"));

    me.lay        =  st.layout(doc);
    me.doc        =  doc;
    me.tc         =  me.lay.tic;
    me.lc         = (me.lay.link < 0)? me.lay.url : me.lay.link;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.tc < 0 || me.lc < 0) return;

    st.showAlert(st.str('nice'), st.str('ctic.start'), 1, st.ya.img);
    me.inProgress = 1;

    ya.next(ya.info, 250);
};