if (!sape) var sape = {};
if (!sape.addform) sape.addform = {};

sape.addform.onClick = function (aEvent)
{
    var st = sape.toolbar, doc = content.document, cc = 0, lay = st.layout(doc);

    var pages = doc.getElementById("check-pages-area").value;
    if (!pages.length) return;

    var page = pages.split("\n");

    for (var i = 0; i < page.length; i++)
    {
        var url = page[i].replace(/\r/, "");

        var r = doc.getElementsByTagName("tr");
        for (var j = 0; j < r.length; j++)
        {
            var col = r[j].getElementsByTagName("td");
            if (col.length < lay.cols) continue;

            var box = col[lay.check].getElementsByTagName("input");
            if (box.length < 1) continue;

            var a = r[j].getElementsByTagName("a");
            for (var k = 0; k < a.length; k++)
            {
               if ((a[k].getAttribute("href") == url) || (a[k].getAttribute("href") == url.replace(/\/$/, "")))
               {
                   box[0].checked = true; cc++;
                   break;
               }
            }
        }
    }
    if (cc > 0) alert(st.str('addform.s3') + ' ' + cc);
};

sape.addform.add = function()
{
    var st = sape.toolbar, doc = content.document;
    if (doc.forms.length > 0)
    {
        var last = doc.forms[doc.forms.length - 1];
        if  (last.innerHTML.indexOf("check-pages-area") > 0) return;

        var inner = doc.createElement('div');
            inner.className = "inner maincol";
            inner.style.margin = "0px";

        var ef = doc.createElement('div');
            ef.className = "export-form";
            ef.style.marginLeft = "250px";
            inner.appendChild(ef);

        var li = doc.createElement('div');
            li.className = "lining";
            ef.appendChild(li);

        var f_h3 = doc.createElement("h3");
            f_h3.appendChild(doc.createTextNode(st.str('addform.s1')));

        var f_ta = doc.createElement("textarea");
            f_ta.setAttribute("id", "check-pages-area");
            f_ta.setAttribute("name", "check-pages-area");
            f_ta.setAttribute("style", "width:100%; height:150px; margin:10px auto;");

        var f_in = doc.createElement("input");
            f_in.setAttribute("id", "check-pages-button");
            f_in.setAttribute("type", "button");
            f_in.setAttribute("name", "check-pages-button");
            f_in.setAttribute("value", st.str('addform.s2'));
            f_in.setAttribute("style", "margin:0px auto;");
            f_in.addEventListener("click", sape.addform.onClick, false);

        var f_fs = doc.createElement("fieldset");
            f_fs.className = "exp";
            f_fs.setAttribute("style", "text-align:center;");
            f_fs.appendChild(f_in);

        var form = doc.createElement('form');
            form.appendChild(f_h3);
            form.appendChild(f_ta);
            form.appendChild(f_fs);
            li.appendChild(form);

        doc.getElementById('content').appendChild(inner);
    }
};

if (!sape.panel) sape.panel = {};
sape.panel.init = function(aEvent)
{
    var doc = aEvent.originalTarget;
    if (doc instanceof HTMLDocument)
    {
            try
            {
                sape.toolbar.initInterface();
            }
            catch(ex) {}
            if (!sape.toolbar.inside(doc)) return;
            if (sape.toolbar.sape(doc)) sape.toolbar.dropRedirects(doc);
    }
    else return;

    var a = doc.getElementById('menu_left');   // sape

    var informer = sape.toolbar.prefs().getBoolPref("informer");
    if (informer)
    {
        var img = doc.createElement("img");
            img.setAttribute("src", "http://seobudget.ru/images/updates/yandex.gif");

        var lnk = doc.createElement("a");
            lnk.setAttribute("href", "http://seobudget.ru/updates/");
            lnk.setAttribute("target", "_blank");
            lnk.appendChild(img);

        var div = doc.createElement("div");
            div.setAttribute("style", "width:100%; text-align:center; margin:0 auto;");
            div.appendChild(lnk);

        if (a) a.appendChild(div);
    }
}

window.addEventListener("DOMContentLoaded", sape.panel.init, false);
