if (!sape) var sape={};
if (!sape.toolbar) sape.toolbar={};

if (!sape.toolbar.exp) sape.toolbar.exp = {};

//------------------------------------------------------------------------------
// Экспорт ссылок
//------------------------------------------------------------------------------

sape.toolbar.exp.links = function()
{
   var  st  = sape.toolbar;
   var  doc = content.document;

   if (!st.sape(doc)) return;

   var  lay = st.layout(doc);
   var  lc  = (lay.url < 0)? lay.link : lay.url;

   if (lc < 0) return;

   var data = new Array();
   var row  = doc.getElementsByTagName('tr');

   for (var i=0; i < row.length; i++)
   {
		var td = row[i].getElementsByTagName('td');
        if (td.length < lay.cols) continue;

        var o = td[lay.check].getElementsByTagName('input');
        if (o.length < 1)  continue;
        if (!st.boxCheck(o[0]) || !o[0].checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href) && (data.indexOf(href) == -1)) data.push(href);
   }

   if (data.length == 0) return st.showAlert(st.str('nice'), st.str('links.nochecked'), 0);

   var text = data.sort().join("\n");

   var nsIFilePicker = Components.interfaces.nsIFilePicker;

   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
       fp.init(window, st.str('fp.saveas'), nsIFilePicker.modeSave);
       fp.defaultString = "links.txt"
       fp.appendFilter(st.str('fp.text'), "*.txt");
       fp.appendFilter(st.str('fp.excel'), "*.xls");
       fp.appendFilter(st.str('fp.all'), "*.*");

   var res = fp.show();
   if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace)
   {
        var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

        foStream.init(fp.file, 0x02 | 0x08 | 0x10, 438, 0);
        foStream.write(text, text.length);
        foStream.close();
   }
};

//------------------------------------------------------------------------------
// Экспорт ссылок в буфер обмена
//------------------------------------------------------------------------------

sape.toolbar.exp.clipboard = function()
{
    var  st  = sape.toolbar;
    var  doc = content.document;
    var  lay = st.layout(doc);
    var  lc  = (lay.url < 0)? lay.link : lay.url;

    if (lc < 0) return;

    var data = new Array();
    var row  = doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
		var td = row[i].getElementsByTagName('td');
        if (td.length < lay.cols) continue;

        var o = td[lay.check].getElementsByTagName('input');
        if (o.length < 1)  continue;
        if (!st.boxCheck(o[0]) || !o[0].checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href) && (data.indexOf(href) == -1)) data.push(href);
    }
    if (!data.length) return st.showAlert(st.str('links.nochecked'), st.str('clipboard'), 0, "chrome://wmsape/skin/copy.png");
    try
    {
        var copytext = data.join("\n");

        var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        if (!str) return false;

        str.data = copytext;

        var Transferable = function(source)
        {
            var res = Components.Constructor("@mozilla.org/widget/transferable;1", "nsITransferable")();
            if ('init' in res)
            {
                if (source instanceof Components.interfaces.nsIDOMWindow)
                    source = source.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation);
                res.init(source);
            }
            return res;
        }

        var trans = Transferable(doc.defaultView);
            trans.addDataFlavor("text/unicode");
            trans.setTransferData("text/unicode", str, copytext.length * 2);

        var clipid = Components.interfaces.nsIClipboard;
        var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
        if (!clip) return false;

        clip.setData(trans, null, clipid.kGlobalClipboard);

        st.showAlert(st.str('links.added') + ' ' + data.length, st.str('clipboard'), 0, "chrome://wmsape/skin/copy.png");
    }
    catch(e){}
};

//------------------------------------------------------------------------------
// Экспорт сообщений / автор блока: chahlic
//------------------------------------------------------------------------------

sape.toolbar.exp.messages = function()
{
    function getMessagesText()
    {
        var text = "";
        var div = content.document.getElementById("message_list");
        if (typeof(div) == 'undefined') return false;

        var table = div.getElementsByTagName("table")[0];
        if (typeof(table) == 'undefined') return false;

        var row = table.getElementsByTagName("tr");
    	for (var i=1; i < row.length; i++)
        {
            var col = row[i].getElementsByTagName("td");
            if (col.length < 2) continue;

            var time = col[0].innerHTML.replace(/<[^>]+>/g, ' ');
            var msg  = col[2].textContent;

            text += time + "\n" + msg + "\n\n";
    	}
    	return (text.length)? text : false;
    };

    function getOptionsMess()
    {
        var st = sape.toolbar, doc = content.document;
        if (!doc.forms.length) return false;

	    var form = "", messPerPage = "", messCount = "", options = "";

        for (var i=0; i < doc.forms.length; i++)
        {
        	    if (doc.forms[i].id != "pginator")
    	        {
        		    form = doc.forms[i];

    				//получаем значение поля "Текст в сообщении"
        		    var s = form.getElementsByTagName("input");
    				for (var j=0; j < s.length; j++)
                    {
    					if (s[j].name=="word" && s[j].value!="")
    					{
	    					options += st.str('msgs.filter') + ' ' + s[j].value + "\n";
    						break;
	    				}
		    		}

    				//получаем значение полей "Тип" и "Дата"
    				options += st.str('msgs.type') + "\n";
    				var s = form.getElementsByTagName("option");
    				var label = "";
	    			for (var j=0; j < s.length; j++)
                    {
		    			if (s[j].selected)
                        {
    						if (s[j].label=="") label = st.str('msgs.all');
	    					else label = s[j].label;
		    				options += label + "\n";
    					}
    				}
                }
        		// Определяем сколько сообщений отображалось на странице
	    		else
		    	{
			    	form = doc.forms[i];
    				var p = form.getElementsByTagName("option");
	    			for (var j=0; j < p.length; j++)
                    {
		    			if (p[j].selected && p[j].textContent)
                        {
			    			messPerPage = st.str('msgs.count') + " " + p[j].textContent + "\n\n";
				    		break;
					    }
    				}
	    		}
        }
		// Получаем общее колличества отобранных сообщений
        var divs = doc.getElementsByTagName("div");
		if (divs.length > 0)
        {
		    for (var i=0; i < divs.length; i++)
            {
			    var div = divs[i];
			    if (div.className=="pagination_selector_total" && div.textContent)
        	    {
                    messCount = div.textContent + "\n";
                    break;
			    }
			}
		}
		return options + messCount + messPerPage;
    };

    var st = sape.toolbar, doc = content.document;
    if (!st.sape(doc)) return;

    var separator = "-------------------------------------------------------------------------";

    var data = getMessagesText();
    if (!data) return st.showAlert(st.str('nice'), st.str('msgs.noone'), 0);

    var header = getOptionsMess();
    if (header) data = separator + "\n" + header + separator + "\n\n" + data + "\n\n" + st.str('msgs.endpage') + "\n" + separator + "\n\n";

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, st.str('fp.saveas'), nsIFilePicker.modeSave);
        fp.defaultString = "messages.txt";
        fp.appendFilter(st.str('fp.text'), "*.txt");
        fp.appendFilter(st.str('fp.all'), "*.*");

    var res = fp.show();
    if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace)
    {
       var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
           foStream.init(fp.file, 0x02 | 0x08 | 0x10, 438, 0);

       var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
           os.init(foStream, "windows-1251", 0, 0);
           os.writeString(data);
           os.close();

       foStream.close();
    }
};