if (!sape) var sape={};

sape.seolib =
{
	API: 'http://www.seolib.ru/script/xmlrpc/server.php?ref=5593',
	login: '',
	passw: '',
    img: "chrome://wmsape/skin/seolib.png",
    skip: true,
    icache: true,
};

sape.seolib.onLoad = function()
{
     var info = sape.seolib.getLogin();
     document.getElementById("seolib-login-field").value = info.login;
     document.getElementById("seolib-password-field").value = info.password;
};

sape.seolib.onAccept = function()
{
     var u = document.getElementById("seolib-login-field");
     var p = document.getElementById("seolib-password-field");
     sape.seolib.setLogin(u.value, p.value);
     return true;
};

sape.seolib.getLogin = function()
{
    var info = {login: null, password: null};
    var host = "chrome://wmsape/seolib";

    if ("@mozilla.org/login-manager;1" in Components.classes)
    {
        try
        {
            var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var logins = myLoginManager.findLogins({}, host, null, 'SeoLib Registration');
            if (logins.length)
            {
                info.login = logins[0].username;
                info.password = logins[0].password;
            }
            if (logins.length > 1)
            {
                try
                {
                    var oldLoginInfo = new nsLoginInfo(host, null, 'SeoLib Registration', logins[1].username, logins[1].password, "", "");
                    myLoginManager.removeLogin(oldLoginInfo);
                }
                catch(ex) {}
            }
        }
        catch(ex) {}
     }
     return info;
};

sape.seolib.setLogin = function(login, password)
{
    var host = "chrome://wmsape/seolib";
    var info = sape.seolib.getLogin();

    if ("@mozilla.org/login-manager;1" in Components.classes)
    {
        try
        {
            var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
            try
            {
                var oldLoginInfo = new nsLoginInfo(host, null, 'SeoLib Registration', info.login, info.password, "", "");
                myLoginManager.removeLogin(oldLoginInfo);
            }
            catch(ex) {}

            var newLoginInfo = new nsLoginInfo(host, null, 'SeoLib Registration', login, password, "", "");
            myLoginManager.addLogin(newLoginInfo);
        }
        catch(ex) {}
    }
};

sape.seolib.init = function()
{
    var st = sape.toolbar, me = sape.seolib;
    var prefs = st.prefs();

    var info = me.getLogin();
    me.login = info.login;
    me.passw = st.md5(info.password);

    me.skip    = prefs.getBoolPref("re.check");
    me.icache  = prefs.getBoolPref("cache");
};

sape.seolib.next = function(me)
{
    var timeout = (arguments.length > 1)?  arguments[1] : 500;
    if (me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
};

sape.seolib.result = function(req, doc)
{
    var st = sape.toolbar;
    try
    {
         var str = req.responseXML.getElementsByTagName("string");
         if (str.length)
         {
             var txt = st.html2text(str[0].textContent, doc);
             var uns  = sape.xmlrpc.unserialize(txt);

             return uns;
         }
         else return [];
    }
    catch(ex) {}
};



//------------------------------------------------------------------------------
// Количество страниц в индексе Google
//------------------------------------------------------------------------------

sape.seolib.gs = function(link, place, row)
{
        var st = sape.toolbar, me = st.google.gs;
        var host = link.split('/')[2].replace(/^www./, '');
        var lhost  = 'http://' + host + '/';

        var params = [sape.seolib.login, sape.seolib.passw, lhost];
        var xml    = sape.xmlrpc.xml('extlinks.checkGooglePages', st.htmlentities(sape.xmlrpc.serialize(params)));
        var req    = new XMLHttpRequest();

        req.open('POST', sape.seolib.API, true);
        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            if (req.status == 200 && req.responseText.length)
            {
                var res = sape.seolib.result(req, place.ownerDocument);
                if (res)
                {
                    if (res.error)
                    {
                            row.removeAttribute('gs');
                            me.inProgress = 0;
                            st.showAlert(res['error'], 'SeoLib.ru', 2, sape.seolib.img);
                            return;
                    }
                    if (isFinite(res.result))
                    {
                        var col = row.getElementsByTagName('td');

                        if (me.showcounters) st.google.placeCounter(col[me.lc], res.result);
                        if (st.google.icache) st.cache.push(lhost, 'gs', res.result);

                        var gcount = parseInt(res.result, 10);
                        if (gcount > 0) place.setAttribute("style", "color:white !important; background-color:green !important;");
                        else
                        {
                            place.setAttribute("style", "color:white !important; background-color:red !important;");

                            var box = col[me.lay.check].getElementsByTagName('input');
                            if (box && !box[0].checked)
                            {
                                box[0].checked = true;
                                me.counter++;
                            }
                        }
                    }
                }
                return st.google.next(me, 100);
            }
            else
            {
                place.setAttribute("style", "color:white !important; background-color:silver !important;");
                return st.google.next(me, 100);
            }
        }
        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        req.setRequestHeader('Content-Length', xml.length);
        req.send(xml);
};

//------------------------------------------------------------------------------
// Проверка кэша Google
//------------------------------------------------------------------------------

sape.seolib.cache = function(link, place, row)
{
        var st = sape.toolbar, me = st.google.gc;
        var params = [sape.seolib.login, sape.seolib.passw, link];
        var xml    = sape.xmlrpc.xml('extlinks.checkGoogleCacheDate', st.htmlentities(sape.xmlrpc.serialize(params)));
        var col    = row.getElementsByTagName('td');

        if (row.hasAttribute('gc.2')) return;
            row.setAttribute('gc.2', '1');

        var cl = me.query(link, 2);

        var req = new XMLHttpRequest();
            req.open('POST', sape.seolib.API, true);

        var requestTimer = st.reqTimer(req, 30000);

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (req.status == 200 && req.responseText.length)
                {
                    var res = sape.seolib.result(req, me.doc);
                    if (res)
                    {
                        if (res.error)
                        {
                            row.removeAttribute('gc.2');
                            me.inProgress = 0;
                            st.showAlert(res['error'], 'SeoLib.ru', 2, sape.seolib.img);
                            return;
                        }
                        if (res.result)
                        {
                            if (res.result.num > 0)
                            {
                               place.setAttribute("style", "color:white !important; background-color:green !important;");
                               if (res.result.cachepage)
                               {
                                   place.href = res.result.cachepage;
                                   if (st.google.icache) st.cache.push(cl, 'gc', res.result.cachepage);
                               }
                               if (res.result.date && res.result.date > 0)
                               {
                                    var fz = function(n) {return "" + ((n > 9)? n : "0" + n)};

                                    var pageDate = new Date(parseInt(res.result.date, 10) * 1000);
                                    var strDate  = fz(pageDate.getDate()) + '.' + fz(pageDate.getMonth() + 1) + '.' + pageDate.getFullYear();

                                    me.placeDate(col[me.lay.ico], strDate);
                                    if (st.google.icache) st.cache.push(cl,  'gcd', strDate);
                               }
                            }
                            if (res.result.num == 0)
                            {
                                place.setAttribute("style", "color:white !important; background-color:red !important;");
                                if (st.google.icache) st.cache.push(cl, 'gc', 404);

                                var box = col[me.lay.check].getElementsByTagName('input');
                                if (box && !box[0].checked)
                                {
                                    box[0].checked = true;
                                    me.counter++;
                                }
                            }
                        }
                    }
                    return st.google.next(me, 100);
                }
                else
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    return st.google.next(me, 100);
                }
            }
        }
        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        req.setRequestHeader('Content-Length', xml.length);
        try {req.send(xml)} catch(e) {req.abort()}
};

//------------------------------------------------------------------------------
// Проверка индексации ссылки link на указанном url в Google
//------------------------------------------------------------------------------

sape.seolib.gl = function(url, link, place, row)
{
        var st = sape.toolbar, me = st.google.gl;
        var params = [sape.seolib.login, sape.seolib.passw, url, link];
        var xml    = sape.xmlrpc.xml('extlinks.checkLinkGoogleIndexed', st.htmlentities(sape.xmlrpc.serialize(params)));
        var col    = row.getElementsByTagName('td');
        var q      = me.query(link, me.gettext(col[me.tc]));

        if (row.hasAttribute('gl')) return;
            row.setAttribute('gl', '1');

        var cl    = me.query(link, url);
        var cache = (st.google.icache)? st.cache.pop(q, 'gc') : null;
        if (cache != null)
        {
            if (cache == 404)
            {
                place.setAttribute("style", "color:white !important; background-color:red !important;");
                var box = col[me.lay.check].getElementsByTagName('input');
                if (box && !box[0].checked)
                {
                    box[0].checked = true;
                    me.counter++;
                }
            }
            if (cache.match(/^http/))
            {
                place.setAttribute("style", "color:white !important; background-color:green !important;");
            }
            return st.google.next(me, 500);
        }

        var req = new XMLHttpRequest();
            req.open('POST', sape.seolib.API, true);

        var requestTimer = st.reqTimer(req, 30000);

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                requestTimer.cancel();
                if (req.status == 200 && req.responseText.length)
                {
                    var res = sape.seolib.result(req, me.doc);
                    if (res)
                    {
                        if (res.error)
                        {
                            row.removeAttribute('gl');
                            me.inProgress = 0;
                            st.showAlert(res['error'], 'SeoLib.ru', 2, sape.seolib.img);
                            return;
                        }
                        if (res.result !== 'undefined')
                        {
                            if (res.result > 0)
                            {
                               place.setAttribute("style", "color:white !important; background-color:green !important;");
                               if (st.google.icache) st.cache.push(q,  'gc', st.google.requestURL + st.urlEncode(q));
                            }
                            if (res.result == 0)
                            {
                                place.setAttribute("style", "color:white !important; background-color:red !important;");
                                if (st.google.icache) st.cache.push(q, 'gc', 404);

                                var box = col[me.lay.check].getElementsByTagName('input');
                                if (box && !box[0].checked)
                                {
                                    box[0].checked = true;
                                    me.counter++;
                                }
                            }
                        }
                    }
                    return st.google.next(me, 100);
                }
                else
                {
                    place.setAttribute("style", "color:white !important; background-color:silver !important;");
                    return st.google.next(me, 100);
                }
            }
        }
        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        req.setRequestHeader('Content-Length', xml.length);
        try {req.send(xml)} catch(e) {req.abort()}
};

//------------------------------------------------------------------------------
// Проверка фильтра `Ты последний`
//------------------------------------------------------------------------------

sape.seolib.last =
{
    inProgress: 0,
    doc: null,
    lay: {},
    lc: -1,
};

sape.seolib.last.nextone = function()
{
    var st = sape.toolbar, me = sape.seolib.last;
    var btnStyle = "color:white !important; text-decoration: none; cursor: help; ";

    var rows = me.doc.getElementsByTagName('tr');
    if (me.doc.defaultView) for (var i=0; i < rows.length; i++)
    {
        var crow = rows[i];
        if (crow.hasAttribute('last_checked')) continue;

        var td = crow.getElementsByTagName("td");
        if (td.length < me.lay.cols) continue;

		var o = td[me.lay.check].getElementsByTagName("input");
        if (o.length < 1) continue;

        var checkbox = o[0];
        if (sape.seolib.skip && checkbox.checked) continue;

        var links = td[me.lc].getElementsByTagName("a");
        if (links.length < me.lay.idx + 1) continue;

        var url = links[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(url)) continue;

        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var URI = ioService.newURI(url, 'windows-1251', null);

        var loader     = me.doc.createElement('img');
            loader.src = 'http://static.sape.ru/common/img/ajax-loader-plugin.gif';

        var ai = td[me.lay.ico].getElementsByTagName('a'), as = 0;
        for (var j=0; j < ai.length; j++)
        {
             if (ai[j].className == 'icon_last') { as = ai[j]; break; }
        }
        if (!as) continue;

        if (sape.seolib.icache)
        {
            var value = st.cache.pop(URI.asciiSpec, 'lst');
            if (["0","1","2"].indexOf(value) > -1)
            {
                as.className = 'icon_last icon_yal';
                as.appendChild(me.doc.createTextNode('FLT'));
                if (value == "0")
                {
                    checkbox.checked = true;
                    as.title = st.str('last.filter');
                    as.setAttribute("style", btnStyle + "background-color:red !important;");
                }
                if (value == "1")
                {
                     as.title = st.str('last.nofilter');
                     as.setAttribute("style", btnStyle + "background-color:green !important;");
                }
                if (value == "2")
                {
                     as.title = st.str('last.unknown');
                     as.setAttribute("style", btnStyle + "background-color:silver !important;");
                }
                continue;
            }
        }

        var params = [sape.seolib.login, sape.seolib.passw, URI.asciiSpec];
        var xml    = sape.xmlrpc.xml('extlinks.checkYandexFilter', st.htmlentities(sape.xmlrpc.serialize(params)));

        var req = new XMLHttpRequest();
            req.open('POST', sape.seolib.API, true);

        var requestTimer = st.reqTimer(req, 30000);

        req.onreadystatechange = function (aEvt)
        {
                if (req.readyState == 4)
                {
                    requestTimer.cancel();
                    if (req.status == 200 && req.responseText.length > 0)
                    {
                        var res = sape.seolib.result(req, me.doc);
                        if (res)
                        {
                            if (res.error)
                            {
                                as.removeChild(loader);
                                crow.removeAttribute('last_checked');

                                st.showAlert('SeoLib.ru', res.error, 2, sape.seolib.img);

                                me.inProgress = 0;
                                return;
                            }
                            if (isFinite(res.result))
                            {
                                as.className = 'icon_last icon_yal';
                                as.replaceChild(me.doc.createTextNode('FLT'), loader);

                                if (res.result == 0)
                                {
                                    checkbox.checked = true;
                                    as.title = st.str('last.filter');
                                    as.setAttribute("style", btnStyle + "background-color:red !important;");
                                }
                                if (res.result == 1)
                                {
                                    as.title = st.str('last.nofilter');
                                    as.setAttribute("style", btnStyle + "background-color:green !important;");
                                }
                                if (res.result == 2)
                                {
                                    as.title = st.str('last.unknown');
                                    as.setAttribute("style", btnStyle + "background-color:silver !important;");
                                }
                                if (sape.seolib.icache) st.cache.push(URI.asciiSpec, 'lst', res.result);

                                return sape.seolib.next(me);
                            }
                        }
                    }
                    else
                    {
                        as.className = 'icon_last icon_yal';
                        as.replaceChild(me.doc.createTextNode('FLT'), loader);

                        as.title = st.str('last.unknown');
                        as.setAttribute("style", btnStyle + "background-color:silver !important;");

                        return sape.seolib.next(me);
                    }
                }
        }
        as.appendChild(loader);
        crow.setAttribute('last_checked', '1');

        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        req.setRequestHeader('Content-Length', xml.length);
        req.send(xml);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert('SeoLib.ru', st.str('ya.finish'), 2, sape.seolib.img);
    }
};

sape.seolib.last.unload = function()
{
    var me = sape.seolib.last;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.seolib.last.start = function()
{
    var st = sape.toolbar, me  = sape.seolib.last;
    if (me.inProgress)
    {
        me.inProgress = 0;
        return st.showAlert('SeoLib.ru', st.str('ya.stop'), 2, sape.seolib.img);
    }
    if (me.doc) me.unload();

    var lay = st.layout(content.document);

    if ((me.lc = (lay.url < 0)? lay.link : lay.url) < 0) return;

    sape.seolib.init();
    if (!sape.seolib.login.length || !sape.seolib.passw.length)
    {
        return st.showAlert('SeoLib.ru', st.str('last.noauth'), 2, sape.seolib.img);
    }
    me.doc = content.document;
    me.lay = lay;

    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
        if (row[i].getAttribute('last_checked') == '1') continue;
        if (row[i].innerHTML.indexOf('icon_last') != -1) continue;

        var col = row[i].getElementsByTagName('td');
        if (me.lay.cols > 0 && col.length < lay.cols) continue;

        var box = col[me.lay.check].getElementsByTagName('input');
        if (box.length < 1) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var URI = ioService.newURI(href, 'windows-1251', null);

        st.antivir(URI.asciiSpec, col[me.lay.check]);

        var as = me.doc.createElement('a');
            as.className = 'icon_last';

        var ai = col[me.lay.ico].getElementsByTagName('a'), yap = 0;
        for (var j=0; j < ai.length; j++)
        {
            if (ai[j].className.match(/icon_/)) yap = ai[j];
        }

        if (yap) yap.parentNode.insertBefore(as, yap.nextSibling);
        else
        {
            var div = me.doc.createElement('div');
            div.style.margin = "2px 0px 4px 0px";
            div.appendChild(as);

            col[me.lay.ico].appendChild(div);
        }
        col[me.lc].className = col[me.lc].className.replace('a_visited', '');
    }
    me.inProgress = 1;
    st.showAlert('SeoLib.ru', st.str('ya.start'), 1, sape.seolib.img);

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    for (var i=0; i < 3; i++) sape.seolib.next(me, 500*(i+1));
};